/*
 * $Id: mib_debug.h,v 1.1 2006/11/23 14:48:40 jeffc Exp $
 *
 * File Name - mib_debug.h
 * Purpose   - Debugging macros and functions.
 */
#ifndef _MIB_DEBUG_H_
#define _MIB_DEBUG_H_

#define AGENT_DEBUG 0

#if AGENT_DEBUG
#define AGENT_DBG(x)    do { diag_printf("MIB DEBUG: "); diag_printf x; \
                              diag_printf("\n"); } while(0);
#else
#define AGENT_DBG(x)
#endif

#define AGENT_ENTER                                                         \
            AGENT_DBG(("==========================================="));     \
            AGENT_DBG(("START FUNCTION  %s  ===", __FUNCTION__))            \
            AGENT_DBG(("==========================================="));

#define AGENT_EXIT                                                          \
            AGENT_DBG(("==========================================="));     \
            AGENT_DBG(("END %s at Line  %d  ===", __FUNCTION__, __LINE__)); \
            AGENT_DBG(("===========================================\n"));

#define AGENT_OID_PRINT(LEN, NAME)                                          \
                int loopIndex;                                              \
                AGENT_DBG (("==== %s OID ====", __FUNCTION__));             \
                for (loopIndex = 0; loopIndex < LEN; loopIndex++)           \
                    AGENT_DBG (("%d", (int)NAME[loopIndex]));               \
                AGENT_DBG (("===== OID End ===="));

#endif /* _MIB_DEBUG_H_ */
