/*
 * $Id: lldp_mib.h,v 1.1 2006/12/29 04:34:51 bhandi Exp $
 */

#ifndef _LLDP_MIBS_H
#define _LLDP_MIBS_H

#define SNMPD_CALLBACK_LLDP    9
#define LLDP_PRINT printf

typedef unsigned long lldp_obj_id;
 
typedef enum lldp_obj_e {
    /* LLDP_CONFIG */
    LLDP_CONFIG_ADMINSTATUS,

    /* LLDP_CONFIG_RX */
    LLDP_CONFIG_NOTIFICATIONINTERVAL,
    LLDP_CONFIG_NOTIFICATIONENABLE,

    /* LLDP_CONFIG_TX */
    LLDP_CONFIG_MESSAGETXINTERVAL,
    LLDP_CONFIG_MESSAGETXHOLDMULTIPLIER,
    LLDP_CONFIG_REINITDELAY,
    LLDP_CONFIG_TXDELAY,
    LLDP_CONFIG_TLVTXENABLE,
    LLDP_CONFIG_MANADDRTABLE,

    /* LLDP_STATS_RX */
    LLDP_STATS_REMTABLESLASTCHANGE,
    LLDP_STATS_REMTABLESINSERTS,
    LLDP_STATS_REMTABLESDELETES,
    LLDP_STATS_REMTABLESDROPS,
    LLDP_STATS_REMTABLESAGEOUTS,
    LLDP_STATS_RXPORTFRAMESDISCARDEDTOTAL,
    LLDP_STATS_RXPORTFRAMESERRORS,
    LLDP_STATS_RXPORTFRAMESTOTAL,
    LLDP_STATS_RXPORTTLVSDISCARDED,
    LLDP_STATS_RXPORTTLVSUNRECOGNISED,
    LLDP_STATS_RXPORTAGEOUTSTOTAL,

    /* LLDP_STATS_TX */
    LLDP_STATS_TXPORTFRAMESTOTAL,

    /* LLDP_LOC_SYS */
    LLDP_LOCDATA_CHASSISIDSUBTYPE,
    LLDP_LOCDATA_CHASSISID,
    LLDP_LOCDATA_PORTIDSUBTYPE,
    LLDP_LOCDATA_PORTID,
    LLDP_LOCDATA_PORTDESC,
    LLDP_LOCDATA_SYSDESC,
    LLDP_LOCDATA_SYSNAME,
    LLDP_LOCDATA_SYSCAPSUPPORTED,
    LLDP_LOCDATA_SYSCAPENABLED,
    LLDP_LOCDATA_MANADDRCOUNT,
    LLDP_LOCDATA_MANADDR,
    LLDP_LOCDATA_MANADDRSUBTYPE,
    LLDP_LOCDATA_MANADDRLEN,
    LLDP_LOCDATA_MANADDRIFSUBTYPE,
    LLDP_LOCDATA_MANADDRIFID,
    LLDP_LOCDATA_MANADDROID,

    /* LLDP_REM_SYS */
    LLDP_REMDATA_TIMEMARK,
    LLDP_REMDATA_CHASSISIDSUBTYPE,
    LLDP_REMDATA_CHASSISID,
    LLDP_REMDATA_PORTIDSUBTYPE,
    LLDP_REMDATA_PORTID,
    LLDP_REMDATA_PORTDESC,
    LLDP_REMDATA_SYSDESC,
    LLDP_REMDATA_SYSNAME,
    LLDP_REMDATA_SYSCAPSUPPORTED,
    LLDP_REMDATA_SYSCAPENABLED,
    LLDP_REMDATA_MANADDRCOUNT,
    LLDP_REMDATA_MANADDRSUBTYPE,
    LLDP_REMDATA_MANADDR,
    LLDP_REMDATA_MANADDRIFSUBTYPE,
    LLDP_REMDATA_MANADDRIFID,
    LLDP_REMDATA_MANADDROID,
    LLDP_REMDATA_UNKNOWNTLVCOUNT,
    LLDP_REMDATA_UNKNOWNTLVTYPE,
    LLDP_REMDATA_UNKNOWNTLVINFO,
    LLDP_REMDATA_ORGDEF,

    /* LLDP_NOTIFY */
    LLDP_NOTIFY_REMTABLECHANGE,

    /* LLDP_MED */
    /* LLDP_MED_CONFIG */
    LLDP_CONFIG_MEDPORTCAPSUP,
    LLDP_CONFIG_MEDDEVICECLASS,
    LLDP_CONFIG_MEDPORTCONFIGTLVTXENABLE,
    LLDP_CONFIG_MEDPORTCONFIGNOTIFICATIONENABLE,
    LLDP_CONFIG_MEDFASTSTARTREPEATCOUNT,
    LLDP_CONFIG_MEDPOEDEVICETYPE,
    LLDP_CONFIG_MEDPOEDEVICECLASS,

    /* LLDP_OPT_MED_POLICY */
    LLDP_LOCDATA_MEDPOLICYCOUNT,
    LLDP__LOCDATA_MEDPOLICYAPPTYPE,
    LLDP_LOCDATA_MEDPOLICYVLANID,
    LLDP_LOCDATA_MEDPOLICYPRIRIOTY,
    LLDP_LOCDATA_MEDPOLICYDESC,
    LLDP_LOCDATA_MEDPOLICYUNKNOWN,
    LLDP_LOCDATA_MEDPOLICYTAGGED,

    /* LLDP_OPT_MED_INVENTORY */
    LLDP_LOCDATA_MEDINVENTORYHARDWAREREV,
    LLDP_LOCDATA_MEDINVENTORYFIRMWAREREV,
    LLDP_LOCDATA_MEDINVENTORYSOFTWAREREV,
    LLDP_LOCDATA_MEDINVENTORYSERIALNO,
    LLDP_LOCDATA_MEDMFGNAME,
    LLDP_LOCDATA_MEDMODELNAME,
    LLDP_LOCDATA_MEDINVENTORYASSETID,

    /* LLDP_OPT_MED_LOCATION */
    LLDP_LOCDATA_MEDLOCSUBTYPE,
    LLDP_LOCDATA_MEDLOCATIONINFO,

    /* LLDP_OPT_MED_POEPSE */
    LLDP_LOCDATA_MEDPOEPSE_DEVICETYPE,
    LLDP_LOCDATA_MEDPOEPSE_PORTPOWERAV,
    LLDP_LOCDATA_MEDPOEPSE_PORTPDPRIORITY,
    LLDP_LOCDATA_MEDPOEPSE_POWERSOURCE,


    /* LLDP_OPT_MED_POEPD */
    LLDP_LOCDATA_MEDPOEPD_POWERREQ,
    LLDP_LOCDATA_MEDPOEPD_POWERSOURCE,
    LLDP_LOCDATA_MEDPOEPD_POWERPRIORITY,

    /* LLDP_MED_REMSYS */
    LLDP_REMDATA_MEDCAPSUP,
    LLDP_REMDATA_MEDCAPCUR,
    LLDP_REMDATA_MEDDEVICECLASS,
    LLDP_REMDATA_MEDMEDIAPOLICYCOUNT,
    LLDP_REMDATA_MEDMEDIAPOLICYAPPTYPE,
    LLDP_REMDATA_MEDMEDIAPOLICYVLANID,
    LLDP_REMDATA_MEDMEDIAPOLICYPRIRIOTY,
    LLDP_REMDATA_MEDMEDIAPOLICYDSCP,
    LLDP_REMDATA_MEDMEDIAPOLICYUNKNOWN,
    LLDP_REMDATA_MEDMEDIAPOLICYTAGGED,
    LLDP_REMDATA_MEDHARDWAREREV,
    LLDP_REMDATA_MEDFIRMWAREREV,
    LLDP_REMDATA_MEDSOFTYWAREREV,
    LLDP_REMDATA_MEDSERIALNO,
    LLDP_REMDATA_MEDMFGNAME,
    LLDP_REMDATA_MEDMODELNAME,
    LLDP_REMDATA_MEDASSETID,
    LLDP_REMDATA_MEDLOCATIONSUBTYPE,
    LLDP_REMDATA_MEDLOCATIONINFO,
    LLDP_REMDATA_MEDXPOEDEVICETYPE,
    LLDP_REMDATA_MEDXPOEPSEPOWERAV,
    LLDP_REMDATA_MEDXPOEPSEPOWERSOURCE,
    LLDP_REMDATA_MEDXPOEPSEPOWERPRIORITY,
    LLDP_REMDATA_MEDXPOEPDPOWERREQ,
    LLDP_REMDATA_MEDXPOEPDPOWERSOURCE,
    LLDP_REMDATA_MEDXPOEPDPOWERPRIORITY,

    /* LLDP_MED_NOTIFY */
    LLDP_NOTIFY_MEDTOPOLOGYCHANGEDETECTED,

    /* LLDP_DOT3 */
    /* LLDP_DOT3_CONFIG */
    LLDP_CONFIG_DOT3PORTTLVTXENABLE,

    /* LLDP_DOT3_LOC_SYS */
    LLDP_LOCDATA_DOT3PORTAUTONEGSUP,
    LLDP_LOCDATA_DOT3PORTAUTONEGENABLED,
    LLDP_LOCDATA_DOT3PORTAUTONEGADVERTISEDCAP,
    LLDP_LOCDATA_DOT3PORTOPERMAUTYPE,
    LLDP_LOCDATA_DOT3POWERPORTCLASS,
    LLDP_LOCDATA_DOT3POWERMDISUP,
    LLDP_LOCDATA_DOT3POWERMDIENABLED,
    LLDP_LOCDATA_DOT3POWERPAIRCONTROLABLE,
    LLDP_LOCDATA_DOT3POWERPAIRS,
    LLDP_LOCDATA_DOT3POWERCLASS,
    LLDP_LOCDATA_DOT3LINKAGGSTATUS,
    LLDP_LOCDATA_DOT3LINKAGGPORTID,
    LLDP_LOCDATA_DOT3MAXFRAMESIZE,

    /* LLDP_DOT3_REM_SYS */
    LLDP_REMDATA_DOT3PORTAUTONEGSUP,
    LLDP_REMDATA_DOT3PORTAUTONEGENABLED,
    LLDP_REMDATA_DOT3PORTAUTONEGADVERTISEDCAP,
    LLDP_REMDATA_DOT3PORTOPERMAUTYPE,
    LLDP_REMDATA_DOT3POWERPORTCLASS,
    LLDP_REMDATA_DOT3POWERMDISUP,
    LLDP_REMDATA_DOT3POWERMDIENABLED,
    LLDP_REMDATA_DOT3POWERPAIRCONTROLABLE,
    LLDP_REMDATA_DOT3POWERPAIRS,
    LLDP_REMDATA_DOT3POWERCLASS,
    LLDP_REMDATA_DOT3LINKAGGSTATUS,
    LLDP_REMDATA_DOT3LINKAGGPORTID,
    LLDP_REMDATA_DOT3MAXFRAMESIZE,


    /* LLDP_DOT1 */
    /* LLDP_DOT1_CONFIG */
    LLDP_CONFIG_DOT1VLANTXENABLE,
    LLDP_CONFIG_DOT1VLANNAMETXENABLE,
    LLDP_CONFIG_DOT1PROTOVLANTXENABLE,
    LLDP_CONFIG_DOT1PROTOCOLTXENABLE,

    /* LLDP_DOT1_LOC_SYS */
    LLDP_LOCDATA_DOT1PORTVLANID,
    LLDP_LOCDATA_DOT1PPVIDCOUNT,
    LLDP_LOCDATA_DOT1PPVID,
    LLDP_LOCDATA_DOT1PROTOVLANSUP,
    LLDP_LOCDATA_DOT1PROTOVLANENABLED,
    LLDP_LOCDATA_DOT1VLANCOUNT,
    LLDP_LOCDATA_DOT1VLANID,
    LLDP_LOCDATA_DOT1VLANNAME,
    LLDP_LOCDATA_DOT1PROTOCOLCOUNT,
    LLDP_LOCDATA_DOT1PROTOCOLID,

    /* LLDP_DOT1_REM_SYS */
    LLDP_REMDATA_DOT1PORTVLANID,
    LLDP_REMDATA_DOT1PROTOVLANCOUNT,
    LLDP_REMDATA_DOT1PROTOVLANID,
    LLDP_REMDATA_DOT1PROTOVLANSUP,
    LLDP_REMDATA_DOT1PROTOVLANENABLED,
    LLDP_REMDATA_DOT1VLANCOUNT,
    LLDP_REMDATA_DOT1VLANID,
    LLDP_REMDATA_DOT1VLANNAME,
    LLDP_REMDATA_DOT1PROTOCOLCOUNT,
    LLDP_REMDATA_DOT1PROTOCOLID,

} lldp_obj_t;


typedef struct lldp_parameters_e{
#define GROUP_LLDP_CONFIG 1
#define GROUP_LLDP_CONFIG_RX 2
#define GROUP_LLDP_CONFIG_TX 3
#define GROUP_LLDP_STATS_RX 4
#define GROUP_LLDP_STATS_TX 5
#define GROUP_LLDP_LOC_SYS 6
#define GROUP_LLDP_REM_SYS 7
#define GROUP_LLDP_NOTIFY  8
#define GROUP_LLDP_MED_CONFIG 9
#define GROUP_LLDP_MED_POLICY 10
#define GROUP_LLDP_MED_INVENTORY 11
#define GROUP_LLDP_MED_LOCATION 13
#define GROUP_LLDP_MED_POEPSE 14
#define GROUP_LLDP_MED_POEPD 15
#define GROUP_LLDP_MED_REMSYS 16
#define GROUP_LLDP_MED_NOTIFY  17
#define GROUP_LLDP_DOT1_CONFIG 18
#define GROUP_LLDP_DOT1_LOC_SYS 19
#define GROUP_LLDP_DOT1_REM_SYS 20
#define GROUP_LLDP_DOT3_CONFIG 21
#define GROUP_LLDP_DOT3_LOC_SYS 22
#define GROUP_LLDP_DOT3_REM_SYS 23
    int group;
    
    lldp_obj_t group_obj;
    
#define CALLBACK_ACT_READ  0
#define CALLBACK_ACT_WRITE 1
    int callback_rw;
    
    int timestamp; /* timestamp */
    int uport; /* user port */
    int msap_index; /* msap_index */
    int list_index; /* any list index */
    int err_val; /* Error Code */
    long value;
    unsigned char buf[1024];
    lldp_obj_id object_id[15];
} lldp_parameters_t;
#endif /* _LLDP_MIBS_H */

