/*
 * $Id: bridge_mib.h,v 1.1 2006/11/23 14:48:40 jeffc Exp $
 */

#ifndef _BRIDGE_MIBS_H
#define _BRIDGE_MIBS_H

#include <ucd-snmp/mib_debug.h>
#include <ucd-snmp/common_funcs.h>
#include <ucd-snmp/mibgroup/mib_defines.h>
#include <ucd-snmp/mibgroup/mibII/bridge_mib_defs.h>

/* 0-5 in eCos, 6 for System,Interface and Dot3, 7 for bridge */
#define SNMPD_CALLBACK_BRIDGE     7

typedef enum bridge_obj_e {
    /* dot1dBase */
    DOT1D_BASEBRIDGEADDRESS,
    DOT1D_BASENUMPORTS,
    DOT1D_BASETYPE,
    DOT1D_BASEPORT,
    DOT1D_BASEPORTIFINDEX,
    DOT1D_BASEPORTCIRCUIT,
    DOT1D_BASEPORTDELAYEXCEEDEDDISCARDS,
    DOT1D_BASEPORTMTUEXCEEDEDDISCARDS,
    /*dot1dExtBase */
    DOT1D_DEVICECAPABILITIES,
    DOT1D_TRAFFICCLASSESENABLED,
    DOT1D_GMRPSTATUS,
    DOT1D_PORTCAPABILITIES,
    /* dot1dGarp */
    DOT1D_PORTGARPJOINTIME,
    DOT1D_PORTGARPLEAVETIME,
    DOT1D_PORTGARPLEAVEALLTIME,
    /* dot1dGmrp */
    DOT1D_PORTGMRPSTATUS,
    DOT1D_PORTGMRPFAILEDREGISTRATIONS,
    DOT1D_PORTGMRPLASTPDUORIGIN,
    /* dot1dPriority */
    DOT1D_PORTDEFAULTUSERPRIORITY,
    DOT1D_PORTNUMTRAFFICCLASSES,
    DOT1D_USERPRIORITY,
    DOT1D_REGENUSERPRIORITY,
    DOT1D_TRAFFICCLASSPRIORITY,
    DOT1D_TRAFFICCLASS,
    DOT1D_PORTOUTBOUNDACCESSPRIORITY,
    /* dot1dStatic */
    DOT1D_STATICADDRESSDUMP,
    DOT1D_STATICADDRESS,
    DOT1D_STATICRECEIVEPORT,
    DOT1D_STATICALLOWEDTOGOTO,
    DOT1D_STATICSTATUS,
    DOT1D_STATICADDRESSCOUNT,
    DOT1D_STATICDATA,
    DOT1D_STATICWRITE,
    /* dot1dStp */
    DOT1D_STPPROTOCOLSPECIFICATION,
    /* Read bridge parameters */
    DOT1D_STPTIMESINCETOPOLOGYCHANGE,
    DOT1D_STPTOPCHANGES,
    DOT1D_STPROOTCOST,
    DOT1D_STPROOTPORT,
    DOT1D_STPMAXAGE,
    DOT1D_STPHELLOTIME,
    DOT1D_STPFORWARDDELAY,
    DOT1D_STPDESIGNATEDROOT,
    DOT1D_STPHOLDTIME,
    DOT1D_STPVERSION,
    DOT1D_STPTXHOLDCOUNT,
    DOT1D_STPPATHCOSTDEFAULT,

    /* Write/read bridge params */
    DOT1D_STPPRIORITY,
    DOT1D_STPBRIDGEMAXAGE,
    DOT1D_STPBRIDGEHELLOTIME,
    DOT1D_STPBRIDGEFORWARDDELAY,
    /* STP Port parameters */
    DOT1D_STPPORT,
    DOT1D_STPPORTPRIORITY,
    DOT1D_STPPORTSTATE,
    DOT1D_STPPORTENABLE,
    DOT1D_STPPORTPATHCOST,
    DOT1D_STPPORTFORWARDTRANSITIONS,
    DOT1D_STPPORTDESIGNATEDROOT,
    DOT1D_STPPORTDESIGNATEDCOST,
    DOT1D_STPPORTDESIGNATEDBRIDGE,
    DOT1D_STPPORTDESIGNATEDPORT,
    DOT1D_STPPORTOPEREDGEPORT,
    DOT1D_STPPORTOPERPOINTTOPOINT,

    DOT1D_STPPORTPROTOCOLMIGRATION,
    DOT1D_STPPORTADMINEDGEPORT,
    DOT1D_STPPORTADMINPOINTTOPOINT,
    DOT1D_STPPORTADMINPATHCOST,
    /* dot1dTp */
    DOT1D_TPLEARNEDENTRYDISCARDS,
    DOT1D_TPAGINGTIME,
    DOT1D_TPFDBADDRESS,
    DOT1D_TPFDBPORT,
    DOT1D_TPFDBSTATUS,
    DOT1D_TPPORT,
    DOT1D_TPPORTMAXINFO,
    DOT1D_TPPORTINFRAMES,
    DOT1D_TPPORTOUTFRAMES,
    DOT1D_TPPORTINDISCARDS,
    /* dot1qBase */
    DOT1Q_VLANVERSIONNUMBER,
    DOT1Q_MAXVLANID,
    DOT1Q_MAXSUPPORTEDVLANS,
    DOT1Q_NUMVLANS,
    DOT1Q_GVRPSTATUS,
    /* dot1qStatic */
    DOT1Q_STATICUNICASTADDRESS,
    DOT1Q_STATICUNICASTRECEIVEPORT,
    DOT1Q_STATICUNICASTALLOWEDTOGOTO,
    DOT1Q_STATICUNICASTSTATUS,
    DOT1Q_STATICMULTICASTADDRESS,
    DOT1Q_STATICMULTICASTRECEIVEPORT,
    DOT1Q_STATICMULTICASTSTATICEGRESSPORTS,
    DOT1Q_STATICMULTICASTFORBIDDENEGRESSPORTS,
    DOT1Q_STATICMULTICASTSTATUS,
    DOT1Q_STATICMULTICASTNUMADDR,
    DOT1Q_STATICMULTICASTGETADDR,
    /* dot1qTp */
    DOT1Q_FDBID,
    DOT1Q_FDBDYNAMICCOUNT,
    DOT1Q_TPFDBADDRESS,
    DOT1Q_TPFDBPORT,
    DOT1Q_TPFDBSTATUS,
    DOT1Q_TPGROUPADDRESS,
    DOT1Q_TPGROUPEGRESSPORTS,
    DOT1Q_TPGROUPLEARNT,
    DOT1Q_FORWARDALLPORTS,
    DOT1Q_FORWARDALLSTATICPORTS,
    DOT1Q_FORWARDALLFORBIDDENPORTS,
    DOT1Q_FORWARDUNREGISTEREDPORTS,
    DOT1Q_FORWARDUNREGISTEREDSTATICPORTS,
    DOT1Q_FORWARDUNREGISTEREDFORBIDDENPORTS,
    /* dot1QVlan */
    DOT1Q_VLANNUMDELETES,
    DOT1Q_NEXTFREELOCALVLANINDEX,
    DOT1Q_CONSTRAINTSETDEFAULT,
    DOT1Q_CONSTRAINTTYPEDEFAULT,
    DOT1Q_VLANTIMEMARK,
    DOT1Q_VLANINDEX,
    DOT1Q_VLANFDBID,
    DOT1Q_VLANCURRENTEGRESSPORTS,
    DOT1Q_VLANCURRENTUNTAGGEDPORTS,
    DOT1Q_VLANSTATUS,
    DOT1Q_VLANCREATIONTIME,
    DOT1Q_VLANSTATICNAME,
    DOT1Q_VLANSTATICEGRESSPORTS,
    DOT1Q_VLANFORBIDDENEGRESSPORTS,
    DOT1Q_VLANSTATICUNTAGGEDPORTS,
    DOT1Q_VLANSTATICROWSTATUS,
    DOT1Q_PVID,
    DOT1Q_PORTACCEPTABLEFRAMETYPES,
    DOT1Q_PORTINGRESSFILTERING,
    DOT1Q_PORTGVRPSTATUS,
    DOT1Q_PORTGVRPFAILEDREGISTRATIONS,
    DOT1Q_PORTGVRPLASTPDUORIGIN,
    DOT1Q_TPVLANPORTINFRAMES,
    DOT1Q_TPVLANPORTOUTFRAMES,
    DOT1Q_TPVLANPORTINDISCARDS,
    DOT1Q_TPVLANPORTINOVERFLOWFRAMES,
    DOT1Q_TPVLANPORTOUTOVERFLOWFRAMES,
    DOT1Q_TPVLANPORTINOVERFLOWDISCARDS,
    DOT1Q_TPVLANPORTHCINFRAMES,
    DOT1Q_TPVLANPORTHCOUTFRAMES,
    DOT1Q_TPVLANPORTHCINDISCARDS,
    DOT1Q_CONSTRAINTVLAN,
    DOT1Q_CONSTRAINTSET,
    DOT1Q_CONSTRAINTTYPE,
    DOT1Q_CONSTRAINTSTATUS,
    DOT1Q_VLANID,
    DOT1Q_VLANCOUNT,
    DOT1Q_VIDQUERY,
    DOT1Q_VLANBULKGET
} bridge_obj_t;

typedef struct bridge_parameters_e{
    int group;
    #define  BRIDGE_DOT1DBASE       0
    #define  BRIDGE_DOT1DEXTBASE    1
    #define  BRIDGE_DOT1DGARP       2
    #define  BRIDGE_DOT1DGMRP       3
    #define  BRIDGE_DOT1DPRIORITY   4
    #define  BRIDGE_DOT1DSTATIC     5
    #define  BRIDGE_DOT1DSTP        6
    #define  BRIDGE_DOT1DTP         7
    #define  BRIDGE_DOT1QBASE       8
    #define  BRIDGE_DOT1QSTATIC     9
    #define  BRIDGE_DOT1QTP         10
    #define  BRIDGE_DOT1QVLAN       11
    
    int callback_rw;
    #define CALLBACK_ACT_READ  0
    #define CALLBACK_ACT_WRITE 1

    bridge_obj_t group_obj;
    bridge_param_t group_param;
    int index; /* can be port, VLAN ID etc */
    unsigned char rv; /* return value */
    unsigned int value;
    unsigned char buf[128];
} bridge_parameters_t;
#endif /* _BRIDGE_MIBS_H */

