/*
 * $Id: bridge_mib_defs.h,v 1.1 2006/11/23 14:48:40 jeffc Exp $
 */
#ifndef _BRIDGE_MIB_DEFS_H_
#define _BRIDGE_MIB_DEFS_H_

#define C_VLAN_NAME_SIZE 32

/* This will be passed to the application layer while doing a 
   get/set for a bridge MIB */
struct bridge_static_s {
    unsigned int port;
    unsigned char mac[6];
    unsigned short vid;
    unsigned int isstatic;
};
typedef struct bridge_static_s bridge_static_t;

struct qbridge_static_s {
    int              vid;
    unsigned char    mac[6];
    unsigned char    ports[16]; /* 128 max possible ports */
};
typedef struct qbridge_static_s qbridge_static_t;

struct qbridge_vlan_s {
    unsigned int     vid; 
    unsigned char    vlanName[C_VLAN_NAME_SIZE];/*!<name of the vlan*/
    unsigned char    tports[16]; /* tagged ports */
    unsigned char    utports[16]; /* untagged ports */
    int              rowStatus;
};
typedef struct qbridge_vlan_s qbridge_vlan_t;


/* Union of all possible bridge MIB callback types */
struct bridge_param_s {
    union {
        bridge_static_t  dot1dstat_param;
        qbridge_static_t dot1qstatic_param;
        qbridge_vlan_t   dot1qvlan_param;
    };
};
typedef struct bridge_param_s bridge_param_t;
#endif /* _BRIDGE_MIB_DEFS_H_ */

