//==========================================================================
//
//      snmp/snmpagent/current/include/mibgroup/mibII/group_mib.h
//
//
//==========================================================================

#ifndef _MIBGROUP_GROUP_H
#define _MIBGROUP_GROUP_H

#include <ucd-snmp/mib_debug.h>
#include <ucd-snmp/mibgroup/mib_defines.h>
#include <ucd-snmp/common_funcs.h>

/* See agent_callbacks.h for #define 0~5 */
#define SNMPD_CALLBACK_GROUPS     6

#define MAX_INTERFACE_NUM 128

#define IF_LINK_NOT_CHANGED 0
#define IF_LINK_CHANGED     1

typedef u_long obj_id;

typedef enum obj_id_e {
    SYSTEM_DESCR,
    SYSTEM_OBJECTID,
    SYSTEM_UPTIME,
    SYSTEM_CONTACT,
    SYSTEM_NAME,
    SYSTEM_LOCATION,
    SYSTEM_SERVICES,
    SYSTEM_VLANMODE,
    SYSTEM_SNMPTRAP,
    SYSTEM_IPTTL,
    SYSTEM_IPFWD,
    IF_NUMBER,
    IF_INDEX,
    IF_DESCR,
    IF_TYPE,
    IF_MTU,
    IF_SPEED,
    IF_PHYSADDRESS,
    IF_ADMINSTATUS,
    IF_OPERSTATUS,
    IF_LASTCHANGE,
    IF_INOCTETS,
    IF_INUCASTPKTS,
    IF_INNUCASTPKTS,
    IF_INDISCARDS,
    IF_INERRORS,
    IF_INUNKNOWNPROTOS,
    IF_OUTOCTETS,
    IF_OUTUCASTPKTS,
    IF_OUTNUCASTPKTS,
    IF_OUTDISCARDS,
    IF_OUTERRORS,
    IF_OUTQLEN,
    IF_SPECIFIC,
    DOT3_STATSINDEX,
    DOT3_STATSALIGNMENTERRORS,
    DOT3_STATSFCSERRORS,
    DOT3_STATSSINGLECOLLISIONFRAMES,
    DOT3_STATSMULTIPLECOLLISIONFRAMES,
    DOT3_STATSSQETESTERRORS,
    DOT3_STATSDEFERREDTRANSMISSIONS,
    DOT3_STATSLATECOLLISIONS,
    DOT3_STATSEXCESSIVECOLLISIONS,
    DOT3_STATSINTERNALMACTRANSMITERRORS,
    DOT3_STATSCARRIERSENSEERRORS,
    DOT3_STATSFRAMETOOLONGS,
    DOT3_STATSINTERNALMACRECEIVEERRORS,
    DOT3_STATSSYMBOLERRORS,
    DOT3_STATSETHERCHIPSET,
    DOT3_STATSDUPLEXSTATUS,
    DOT3_STATSRATECONTROLABILITY,
    DOT3_STATSRATECONTROLSTATUS,
    DOT3_COLLINDEX,
    DOT3_COLLCOUNT,
    DOT3_COLLFREQUENCIES,
    DOT3_SYSSTATS,
    DOT3_CNTRLFUNSSUP,
    DOT3_CNTRLINUNKNOWNOPCODES,
    DOT3_PAUSEADMINMODE,
    DOT3_PAUSEOPERMODE,
    DOT3_INPAUSEFRAMES,
    DOT3_OUTPAUSEFRAMES,
	/* at */
    AT_IFINDEX,
	AT_PHYSADDRESS,
	AT_NETADDRESS,
    AT_COUNT,
	/* EGP */
	EGP_INMSGS,
	EGP_INERRORS,
	EGP_OUTMSGS,
	EGP_OUTERRORS,
	EGP_AS,
	EGP_NEIGHSTATE,
	EGP_NEIGHADDR,
	EGP_NEIGHAS,
	EGP_NEIGHINMSGS,
	EGP_NEIGHINERRS,
	EGP_NEIGHOUTMSGS,
	EGP_NEIGHOUTERRS,
	EGP_NEIGHINERRMSGS,
	EGP_NEIGHOUTERRMSGS,
	EGP_NEIGHSTATEUPS,
	EGP_NEIGHSTATEDOWNS,
	EGP_NEIGHINTERVALHELLO,
	EGP_NEIGHINTERVALPOLL,
	EGP_NEIGHMODE,
	EGP_NEIGHEVENTTRIGGER
} obj_id_t;

typedef enum STATPARAM_e {
    SNMP_STATS_INVALID = -1,
    SNMP_STATS_IP_INRCVS,
    SNMP_STATS_IP_HDRERRORS,
    SNMP_STATS_IP_FWDGRMS,
    SNMP_STATS_IP_INDISCARDS
} STATPARAM_t;

typedef struct group_parameters_e{
    int group;
    #define GROUP_SYSTEM     0
    #define GROUP_INTERFACES 1
    #define GROUP_DOT3       2
    #define GROUP_AT         3
    #define GROUP_EGP        4
    
    int callback_rw;
    #define CALLBACK_ACT_READ  0
    #define CALLBACK_ACT_WRITE 1

    obj_id_t group_obj;
    int uport; /* user port */
    unsigned int value;
    unsigned char buf[256];
    obj_id object_id[10];
} group_parameters_t;



#endif /* _MIBGROUP_GROUP_H */
