#ifndef __MIB_DEFINES_H__
#define __MIB_DEFINES_H__

/* Generic directives */
#define OID_NOT_WRITABLE            0
#define IP_ADDRESS_LEN              4
#define IP_STRING_LEN               16
#define MAC_ADDRESS_LEN             6
#define INTERFACE_BYTE_COUNT        8

/* Enable or disable values */
#define MIB_STATUS_ENABLED          1
#define MIB_STATUS_DISABLED         2

/* Return codes */
#define MIB_STATUS_SUCCESS          0
#define MIB_STATUS_ERROR            1

/* Row Status Values */
#define MIB_ROWSTATUS_ACTIVE        1
#define MIB_ROWSTATUS_NOTREADY      3
#define MIB_ROWSTATUS_CREATEANDGO   4
#define MIB_ROWSTATUS_CREATEANDWAIT 5
#define MIB_ROWSTATUS_DESTROY       6

/* ng700ss MIBs description*/
#define SS_NGR_NG700_MIB           "gs108tMib"
#define SS_HOST_GROUP_MIB           "ssHostGroup"
#define SS_MISC_GROUP_MIB           "ssMiscGroup"
#define SS_SPAN_GROUP_MIB           "ssSpanGroup"
#define SS_CONF_GROUP_MIB           "ssConfigGroup"
#define SS_PVLAN_GROUP_MIB          "ssPVlanGroup"
#define SS_TVLAN_GROUP_MIB          "ssTVlanGroup"
#define SS_TRUNK_GROUP_MIB          "ssTrunkGroup"
#define SS_QOS_GROUP_MIB            "ssQosGroup"
#define SS_TRUSTMAC_GROUP_MIB       "ssTrustMacGroup"
#define SS_RATELIMIT_GROUP_MIB      "ssRateLimitGroup"
#define SS_IGMPSNOOP_GROUP_MIB      "ssIgmpSnoopGroup"
#define SS_STATICMCAST_GROUP_MIB    "ssStaticMulticastGroup"
#define SS_MGMTVLAN_GROUP_MIB       "ssMgmtVlanGroup"
#define SS_STROM_GROUP_MIB          "ssStormCtrlGroup"


/* MIBII MIBs description */
#define MIBII_AT_MIB                "atMIB"
#define MIBII_DOT1DBASE_MIB         "dot1dBase"
#define MIBII_DOT1DEXTBASE_MIB      "dot1dExtBase"
#define MIBII_DOT1DGARP_MIB         "dot1dGarp"
#define MIBII_DOT1DGMRP_MIB         "dot1dGmrp"
#define MIBII_DOT1DPRIORITY_MIB     "dot1dPriority"
#define MIBII_DOT1DSTATIC_MIB       "dot1dStatic"
#define MIBII_DOT1DSTP_MIB          "dot1dStp"
#define MIBII_DOT1DTP_MIB           "dot1dTp"
#define MIBII_DOT1QBASE_MIB         "dot1qBase"
#define MIBII_DOT1QSTATIC_MIB       "dot1qStatic"
#define MIBII_DOT1QTP_MIB           "dot1qTp"
#define MIBII_DOT1QVLAN_MIB         "dot1qVlan"

/* ssHost group directives */
#define HOST_ATTRIB_RONLY           1
#define HOST_ATTRIB_RWRITE          2

/* ssConfGroup directives */
#define MIB_VLAN_MODE_PORTBASED     1
#define MIB_VLAN_MODE_TAGGED        2

/* ssQos directives */
#define SS_QOS_MODE_PORTBASED       1
#define SS_QOS_MODE_1PBASED         2
#define SS_QOS_MODE_TOSBASED        3
#define SS_QOS_MODE_DSCPBASED       4
#define SS_TOS_NUM_QUEUES           8
#define SS_QOS_PRIO_LOWEST          1
#define SS_QOS_PRIO_HIGHEST         4
#define SS_QOS_MIN_PRIORITY         1
#define SS_QOS_MAX_PRIORITY         8

/* ssTvlan group directives */
#define SS_TVLAN_PORT_PRIO_MIN      0
#define SS_TVLAN_PORT_PRIO_MAX      7

/* Spanning tree directives */
#define C_BRIDGE_ROOT_LEN           8
#define C_STP_PRIORITY_MASK         0x0FFF
#define C_BRIDGE_MIN_MAXAGE         600
#define C_BRIDGE_MAX_MAXAGE         4000
#define C_BRIDGE_MIN_HELLOTIME      100
#define C_BRIDGE_MAX_HELLOTIME      1000
#define C_BRIDGE_MIN_FWDELAY        400
#define C_BRIDGE_MAX_FWDELAY        3000
#define C_BRIDGE_STPVER_STPCOMPAT   0
#define C_BRIDGE_STPVER_RSTP        2
#define C_STP_TXHOLDCNT_MIN         1
#define C_STP_TXHOLDCNT_MAX         10
#define C_STP_PCOST_1998            1
#define C_STP_PCOST_2001            2
#define C_STP_PORTPRIO_MAX          255
#define C_STP_PATHCOST_MAX          65535
#define C_STP_PRIORITY_MAX          65535
#define C_STP_ADMINP2P_TRUE         0
#define C_STP_ADMINP2P_AUTO         2

/* TP directives */
#define C_L2_AGINGTIME_MIN          10
#define C_L2_AGINGTIME_MAX          1000000

/* dot1d/dot1qStatic directives */
#define C_STATIC_STATUS_OTHER       1 
#define C_STATIC_STATUS_INVALID     2
#define C_STATIC_STATUS_PERMANENT   3
#define C_STATIC_STATUS_DELONRESET  4
#define C_STATIC_STATUS_DELONTMOUT  5

/* VLAN directives */
#define C_PORT_FRAMETYPE_ALL        1
#define C_PORT_FRAMETYPE_TAGGED     2

/*storm control setting */
#define STORM_BCST_MCST      1
#define STORM_BCST_ONLY      2
#define STORM_DISABLE        3
#define STORM_BCST_MCST_DLF  4
#define DISABLE              0

/*storm Limit select*/
#define STORM_LIMIT_152KBPS     152
#define STORM_LIMIT_1520KBPS    1520
#define STORM_LIMIT_15200KBPS   15200
#define STORM_LIMIT_152000KBPS  152000
#define STORM_LIMIT_500000KBPS  5000000
#define STORM_LIMIT_1000000KBPS 1000000


#define STORMLIMIT152KBPS     1 
#define STORMLIMIT1520KBPS    2
#define STORMLIMIT15200KBPS   3
#define STORMLIMIT152000KBPS  4
#define STORMLIMIT500000KBPS  5
#define STORMLIMIT1000000KBPS 6
/*Rate Limit*/
#define RATE_LIMIT_512KBPS  512
#define RATE_LIMIT_2MBPS    2048
#define RATE_LIMIT_4MBPS    4096
#define RATE_LIMIT_10MBPS   10240
#define RATE_LIMIT_20MBPS   20480
#define RATE_LIMIT_40MBPS   40960
#define RATE_LIMIT_60MBPS   61440
#define RATE_LIMIT_100MBPS  102400
#define RATE_LIMIT_200MBPS  204800
#define RATE_LIMIT_400MBPS  409600
#define RATE_LIMIT_1000MBPS 1024000
#define RATE_NOLIMIT       0
#define RATE_DEFAULT_KBPS   64

#define RATE512KBPS      1
#define RATE2MBPS        2
#define RATE4MBPS        3
#define RATE10MBPS       4
#define RATE20MBPS       5
#define RATE40MBPS       6
#define RATE60MBPS       7
#define RATE100MBPS      8
#define RATE200MBPS      9
#define RATE400MBPS      10
#define RATE1000MBPS     11

/*IP Assignment*/
#define MANUAL    1
#define DHCP      2
#define OTHER     3

/*Config Port*/
#define SSP_DISABLE   1
#define SSP_AUTO      2
#define SSP_HALF_10   3
#define SSP_FULL_10   4
#define SSP_HALF_100  5
#define SSP_FULL_100  6
#define SSP_HALF_1000 7
#define SSP_FULL_1000 8

#define SSP_OPER_DOWN      1
#define SSP_OPER_HALF_10   2
#define SSP_OPER_FULL_10   3
#define SSP_OPER_HALF_100  4
#define SSP_OPER_FULL_100  5
#define SSP_OPER_HALF_1000 6
#define SSP_OPER_FULL_1000 7

#define PORTSPEED_10    10
#define PORTSPEED_100   100
#define PORTSPEED_1000  1000

/*Config Mirror*/

#define MIRROR_MODE_DISABLE 0
#define MIRROR_MODE_INGRESS 1
#define MIRROR_MODE_EGRESS  2
#define MIRROR_MODE_BOTH    3

#define MIRROR_NO_ROW       0
#define MIRROR_ROW_EXIST    1

/*firmware upload and download (TFTP)*/
#define TFTPUPLOAD  2
#define TFTPDOWNLOAD 1
#define DOWNLOAD     1
#define UPLOAD       0

/* Config Save */
#define SAVE        1
#define NOOP        2
#endif
