#include <config.h>

/* minimal include directives */
#include "mibincl.h"
#include "mibgroup/util_funcs.h"

#include <pkgconf/system.h>

#include <ucd-snmp/mibgroup/iso/lldp_mib.h>
#include <ucd-snmp/mibgroup/mibII/group_mib.h>

#include "mibgroup/iso/lldpXdot3MIB.h"

static lldp_parameters_t *lldp_parms = NULL;
static group_parameters_t *interface_parms = NULL;
extern int interface_count;


/*
 * Note: this file originally auto-generated by mib2c using
 *        : mib2c.old-api.conf,v 1.4.6.2 2006/04/18 17:36:51 hardaker Exp $
 */


/* 
 * lldpXdot3MIB_variables_oid:
 *   this is the top level oid that we want to register under.  This
 *   is essentially a prefix, with the suffix appearing in the
 *   variable below.
 */

oid lldpXdot3MIB_variables_oid[] = { 1,0,8802,1,1,2,1,5,4623 };

/* 
 * variable4 lldpXdot3MIB_variables:
 *   this variable defines function callbacks and type return information 
 *   for the lldpXdot3MIB mib section 
 */

struct variable7 lldpXdot3MIB_variables[] = {
    /*  magic number        , variable type , ro/rw , callback fn  , L, oidsuffix */

#define LLDPXDOT3PORTCONFIGTLVSTXENABLE		1
    {LLDPXDOT3PORTCONFIGTLVSTXENABLE,  ASN_OCTET_STR,  RWRITE,  var_lldpXdot3PortConfigTable, 5,  { 1,1,1, 1, 1 }},
#define LLDPXDOT3LOCPORTAUTONEGSUPPORTED		2
    {LLDPXDOT3LOCPORTAUTONEGSUPPORTED,  ASN_INTEGER,  RONLY,   var_lldpXdot3LocPortTable, 5,  { 1,2,1, 1, 1 }},
#define LLDPXDOT3LOCPORTAUTONEGENABLED		3
    {LLDPXDOT3LOCPORTAUTONEGENABLED,  ASN_INTEGER,  RONLY,   var_lldpXdot3LocPortTable, 5,  { 1,2,1, 1, 2 }},
#define LLDPXDOT3LOCPORTAUTONEGADVERTISEDCAP		4
    {LLDPXDOT3LOCPORTAUTONEGADVERTISEDCAP,  ASN_OCTET_STR,  RONLY,   var_lldpXdot3LocPortTable, 5,  { 1,2,1, 1, 3 }},
#define LLDPXDOT3LOCPORTOPERMAUTYPE		5
    {LLDPXDOT3LOCPORTOPERMAUTYPE,  ASN_INTEGER,  RONLY,   var_lldpXdot3LocPortTable, 5,  { 1,2,1, 1, 4 }},
#define LLDPXDOT3LOCPOWERPORTCLASS		6
    {LLDPXDOT3LOCPOWERPORTCLASS,  ASN_INTEGER,  RONLY,   var_lldpXdot3LocPowerTable, 5,  { 1,2,2, 1, 1 }},
#define LLDPXDOT3LOCPOWERMDISUPPORTED		7
    {LLDPXDOT3LOCPOWERMDISUPPORTED,  ASN_INTEGER,  RONLY,   var_lldpXdot3LocPowerTable, 5,  { 1,2,2, 1, 2 }},
#define LLDPXDOT3LOCPOWERMDIENABLED		8
    {LLDPXDOT3LOCPOWERMDIENABLED,  ASN_INTEGER,  RONLY,   var_lldpXdot3LocPowerTable, 5,  { 1,2,2, 1, 3 }},
#define LLDPXDOT3LOCPOWERPAIRCONTROLABLE		9
    {LLDPXDOT3LOCPOWERPAIRCONTROLABLE,  ASN_INTEGER,  RONLY,   var_lldpXdot3LocPowerTable, 5,  { 1,2,2, 1, 4 }},
#define LLDPXDOT3LOCPOWERPAIRS		10
    {LLDPXDOT3LOCPOWERPAIRS,  ASN_INTEGER,  RONLY,   var_lldpXdot3LocPowerTable, 5,  { 1,2,2, 1, 5 }},
#define LLDPXDOT3LOCPOWERCLASS		11
    {LLDPXDOT3LOCPOWERCLASS,  ASN_INTEGER,  RONLY,   var_lldpXdot3LocPowerTable, 5,  { 1,2,2, 1, 6 }},
#define LLDPXDOT3LOCLINKAGGSTATUS		12
    {LLDPXDOT3LOCLINKAGGSTATUS,  ASN_OCTET_STR,  RONLY,   var_lldpXdot3LocLinkAggTable, 5,  { 1,2,3, 1, 1 }},
#define LLDPXDOT3LOCLINKAGGPORTID		13
    {LLDPXDOT3LOCLINKAGGPORTID,  ASN_INTEGER,  RONLY,   var_lldpXdot3LocLinkAggTable, 5,  { 1,2,3, 1, 2 }},
#define LLDPXDOT3LOCMAXFRAMESIZE		14
    {LLDPXDOT3LOCMAXFRAMESIZE,  ASN_INTEGER,  RONLY,   var_lldpXdot3LocMaxFrameSizeTable, 5,  { 1,2,4, 1, 1 }},
#define LLDPXDOT3REMPORTAUTONEGSUPPORTED		15
    {LLDPXDOT3REMPORTAUTONEGSUPPORTED,  ASN_INTEGER,  RONLY,   var_lldpXdot3RemPortTable, 5,  { 1,3,1, 1, 1 }},
#define LLDPXDOT3REMPORTAUTONEGENABLED		16
    {LLDPXDOT3REMPORTAUTONEGENABLED,  ASN_INTEGER,  RONLY,   var_lldpXdot3RemPortTable, 5,  { 1,3,1, 1, 2 }},
#define LLDPXDOT3REMPORTAUTONEGADVERTISEDCAP		17
    {LLDPXDOT3REMPORTAUTONEGADVERTISEDCAP,  ASN_OCTET_STR,  RONLY,   var_lldpXdot3RemPortTable, 5,  { 1,3,1, 1, 3 }},
#define LLDPXDOT3REMPORTOPERMAUTYPE		18
    {LLDPXDOT3REMPORTOPERMAUTYPE,  ASN_INTEGER,  RONLY,   var_lldpXdot3RemPortTable, 5,  { 1,3,1, 1, 4 }},
#define LLDPXDOT3REMPOWERPORTCLASS		19
    {LLDPXDOT3REMPOWERPORTCLASS,  ASN_INTEGER,  RONLY,   var_lldpXdot3RemPowerTable, 5,  { 1,3,2, 1, 1 }},
#define LLDPXDOT3REMPOWERMDISUPPORTED		20
    {LLDPXDOT3REMPOWERMDISUPPORTED,  ASN_INTEGER,  RONLY,   var_lldpXdot3RemPowerTable, 5,  { 1,3,2, 1, 2 }},
#define LLDPXDOT3REMPOWERMDIENABLED		21
    {LLDPXDOT3REMPOWERMDIENABLED,  ASN_INTEGER,  RONLY,   var_lldpXdot3RemPowerTable, 5,  { 1,3,2, 1, 3 }},
#define LLDPXDOT3REMPOWERPAIRCONTROLABLE		22
    {LLDPXDOT3REMPOWERPAIRCONTROLABLE,  ASN_INTEGER,  RONLY,   var_lldpXdot3RemPowerTable, 5,  { 1,3,2, 1, 4 }},
#define LLDPXDOT3REMPOWERPAIRS		23
    {LLDPXDOT3REMPOWERPAIRS,  ASN_INTEGER,  RONLY,   var_lldpXdot3RemPowerTable, 5,  { 1,3,2, 1, 5 }},
#define LLDPXDOT3REMPOWERCLASS		24
    {LLDPXDOT3REMPOWERCLASS,  ASN_INTEGER,  RONLY,   var_lldpXdot3RemPowerTable, 5,  { 1,3,2, 1, 6 }},
#define LLDPXDOT3REMLINKAGGSTATUS		25
    {LLDPXDOT3REMLINKAGGSTATUS,  ASN_OCTET_STR,  RONLY,   var_lldpXdot3RemLinkAggTable, 5,  { 1,3,3, 1, 1 }},
#define LLDPXDOT3REMLINKAGGPORTID		26
    {LLDPXDOT3REMLINKAGGPORTID,  ASN_INTEGER,  RONLY,   var_lldpXdot3RemLinkAggTable, 5,  { 1,3,3, 1, 2 }},
#define LLDPXDOT3REMMAXFRAMESIZE		27
    {LLDPXDOT3REMMAXFRAMESIZE,  ASN_INTEGER,  RONLY,   var_lldpXdot3RemMaxFrameSizeTable, 5,  { 1,3,4, 1, 1 }},
};
/*    (L = length of the oidsuffix) */


/** Initializes the lldpXdot3MIB module */
void
init_lldpXdot3MIB(void)
{
    DEBUGMSGTL(("lldpXdot3MIB", "Initializing\n"));

    /* register ourselves with the agent to handle our mib tree */
    REGISTER_MIB("lldpXdot3MIB", lldpXdot3MIB_variables, variable7,
            lldpXdot3MIB_variables_oid);

    lldp_parms = (lldp_parameters_t *) 
                 sal_alloc(sizeof(lldp_parameters_t), "lldp_parms");
    interface_parms = (group_parameters_t *) 
                 sal_alloc(sizeof(group_parameters_t), "group_parms");
}

/*
 * var_lldpXdot3MIB():
 *   This function is called every time the agent gets a request for
 *   a scalar variable that might be found within your mib section
 *   registered above.  It is up to you to do the right thing and
 *   return the correct value.
 *     You should also correct the value of "var_len" if necessary.
 *
 *   Please see the documentation for more information about writing
 *   module extensions, and check out the examples in the examples
 *   and mibII directories.
 */
unsigned char *
var_lldpXdot3MIB(struct variable *vp, 
        oid     *name, 
        size_t  *length, 
        int     exact, 
        size_t  *var_len, 
        WriteMethod **write_method)
{
    if(header_generic(vp,name,length,exact,var_len,write_method)
            == MATCH_FAILED )
        return NULL;

    /* 
     * this is where we do the value assignments for the mib results.
     */
    switch(vp->magic) {
        default:
            ERROR_MSG("");
    }
    return NULL;
}

/*
 * var_lldpXdot3PortConfigTable():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_lldpXdot3MIB above.
 */
unsigned char *
var_lldpXdot3PortConfigTable(struct variable *vp,
        oid     *name,
        size_t  *length,
        int     exact,
        size_t  *var_len,
        WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;

    /* 
     * This assumes that the table is a 'simple' table.
     *	See the implementation documentation for the meaning of this.
     *	You will need to provide the correct value for the TABLE_SIZE parameter
     *
     * If this table does not meet the requirements for a simple table,
     *	you will need to provide the replacement code yourself.
     *	Mib2c is not smart enough to write this for you.
     *    Again, see the implementation documentation for what is required.
     */
    if(!interface_count)
    {
        interface_parms->group_obj=IF_NUMBER;
        interface_parms->group=GROUP_INTERFACES;
        snmp_call_callbacks(SNMP_CALLBACK_APPLICATION,
                SNMPD_CALLBACK_GROUPS,
                interface_parms);	
        interface_count=(int)interface_parms->value;
    }
    if (header_simple_table(vp,name,length,exact,var_len,write_method, interface_count)
            == MATCH_FAILED )
        return NULL;

    lldp_parms->uport = name[(*length) - 1] - 1;

    /* 
     * this is where we do the value assignments for the mib results.
     */
    lldp_parms->callback_rw = CALLBACK_ACT_READ;
    lldp_parms->group   =  GROUP_LLDP_DOT3_CONFIG;
    switch(vp->magic) {
        case LLDPXDOT3PORTCONFIGTLVSTXENABLE:
            *write_method = write_lldpXdot3PortConfigTLVsTxEnable;
            lldp_parms->group_obj = LLDP_CONFIG_DOT3PORTTLVTXENABLE;
            /* Callback */
            snmp_call_callbacks(SNMP_CALLBACK_APPLICATION,
                    SNMPD_CALLBACK_LLDP,
                    lldp_parms);
            if(lldp_parms->err_val != 0)
            {
                return NULL;
            }
            *var_len = sizeof(long);
            long_ret = (long)lldp_parms->value;
            return (u_char *)&long_ret;
            break;
        default:
            ERROR_MSG("");
    }
    return NULL;
}

/*
 * var_lldpXdot3LocPortTable():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_lldpXdot3MIB above.
 */
unsigned char *
var_lldpXdot3LocPortTable(struct variable *vp,
        oid     *name,
        size_t  *length,
        int     exact,
        size_t  *var_len,
        WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static char buffer[2];

    /*
     * Since the interface_count variable will be used always.
     * Store it as a global variable.
     */
    if (!interface_count) {
        interface_parms->group_obj = IF_NUMBER;
        interface_parms->group = GROUP_INTERFACES;
        snmp_call_callbacks(SNMP_CALLBACK_APPLICATION,
                SNMPD_CALLBACK_GROUPS,
                interface_parms);
        interface_count = (int)interface_parms->value;
    }

    /* 
     * This assumes that the table is a 'simple' table.
     *	See the implementation documentation for the meaning of this.
     *	You will need to provide the correct value for the TABLE_SIZE parameter
     *
     * If this table does not meet the requirements for a simple table,
     *	you will need to provide the replacement code yourself.
     *	Mib2c is not smart enough to write this for you.
     *    Again, see the implementation documentation for what is required.
     */
    if (header_simple_table(vp,name,length,exact,var_len,write_method,interface_count)
            == MATCH_FAILED )
        return NULL;

    lldp_parms->uport = name[(*length) - 1] - 1;

    /* 
     * this is where we do the value assignments for the mib results.
     */
    lldp_parms->callback_rw = CALLBACK_ACT_READ;
    lldp_parms->group   =  GROUP_LLDP_DOT3_LOC_SYS;
    switch(vp->magic) {
        case LLDPXDOT3LOCPORTAUTONEGSUPPORTED:
            lldp_parms->group_obj = LLDP_LOCDATA_DOT3PORTAUTONEGSUP;
            /* Callback */
            snmp_call_callbacks(SNMP_CALLBACK_APPLICATION,
                    SNMPD_CALLBACK_LLDP,
                    lldp_parms);
            if(lldp_parms->err_val != 0)
            {
                return NULL;
            }
            *var_len = sizeof(long);
            long_ret = (long)lldp_parms->value;
            break;
        case LLDPXDOT3LOCPORTAUTONEGENABLED:
            lldp_parms->group_obj = LLDP_LOCDATA_DOT3PORTAUTONEGENABLED;
            /* Callback */
            snmp_call_callbacks(SNMP_CALLBACK_APPLICATION,
                    SNMPD_CALLBACK_LLDP,
                    lldp_parms);
            if(lldp_parms->err_val != 0)
            {
                return NULL;
            }
            *var_len = sizeof(long);
            long_ret = (long)lldp_parms->value;
            break;
        case LLDPXDOT3LOCPORTAUTONEGADVERTISEDCAP:
            lldp_parms->group_obj = LLDP_LOCDATA_DOT3PORTAUTONEGADVERTISEDCAP;
            /* Callback */
            snmp_call_callbacks(SNMP_CALLBACK_APPLICATION,
                    SNMPD_CALLBACK_LLDP,
                    lldp_parms);
            if(lldp_parms->err_val != 0)
            {
                return NULL;
            }
            *var_len = 2;
            memcpy(buffer,lldp_parms->buf,2);
            return buffer;
            break;
        case LLDPXDOT3LOCPORTOPERMAUTYPE:
            lldp_parms->group_obj = LLDP_LOCDATA_DOT3PORTOPERMAUTYPE;
            /* Callback */
            snmp_call_callbacks(SNMP_CALLBACK_APPLICATION,
                    SNMPD_CALLBACK_LLDP,
                    lldp_parms);
            if(lldp_parms->err_val != 0)
            {
                return NULL;
            }
            *var_len = sizeof(long);
            long_ret = (long)lldp_parms->value;
            break;
        default:
            ERROR_MSG("");
            return NULL;
    }

    /* Give the value back */
    return (u_char *)&long_ret;
}

/*
 * var_lldpXdot3LocPowerTable():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_lldpXdot3MIB above.
 */
unsigned char *
var_lldpXdot3LocPowerTable(struct variable *vp,
        oid     *name,
        size_t  *length,
        int     exact,
        size_t  *var_len,
        WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    
    if (!interface_count) {
        interface_parms->group_obj = IF_NUMBER;
        interface_parms->group = GROUP_INTERFACES;
        snmp_call_callbacks(SNMP_CALLBACK_APPLICATION,
                SNMPD_CALLBACK_GROUPS,
                interface_parms);
        interface_count = (int)interface_parms->value;
    }

    /* 
     * This assumes that the table is a 'simple' table.
     *	See the implementation documentation for the meaning of this.
     *	You will need to provide the correct value for the TABLE_SIZE parameter
     *
     * If this table does not meet the requirements for a simple table,
     *	you will need to provide the replacement code yourself.
     *	Mib2c is not smart enough to write this for you.
     *    Again, see the implementation documentation for what is required.
     */
    if (header_simple_table(vp,name,length,exact,var_len,write_method,interface_count)
            == MATCH_FAILED )
        return NULL;

    lldp_parms->uport = name[(*length) - 1] - 1;

    /* 
     * this is where we do the value assignments for the mib results.
     */
    lldp_parms->group   =  GROUP_LLDP_DOT3_LOC_SYS;
    lldp_parms->callback_rw = CALLBACK_ACT_READ;
    switch(vp->magic) {
        case LLDPXDOT3LOCPOWERPORTCLASS:
            lldp_parms->group_obj = LLDP_LOCDATA_DOT3POWERPORTCLASS;
            snmp_call_callbacks(SNMP_CALLBACK_APPLICATION,
                    SNMPD_CALLBACK_LLDP,
                    lldp_parms);
            if(lldp_parms->err_val != 0)
            {
                return NULL;
            }
            *var_len = sizeof(long);
            long_ret = lldp_parms->value;
            break;
        case LLDPXDOT3LOCPOWERMDISUPPORTED:
            lldp_parms->group_obj =LLDP_LOCDATA_DOT3POWERMDISUP;
            snmp_call_callbacks(SNMP_CALLBACK_APPLICATION,
                    SNMPD_CALLBACK_LLDP,
                    lldp_parms);
            if(lldp_parms->err_val != 0)
            {
                return NULL;
            }
            *var_len = sizeof(long);
            long_ret = (long)lldp_parms->value;
            break;
        case LLDPXDOT3LOCPOWERMDIENABLED:
            lldp_parms->group_obj =LLDP_LOCDATA_DOT3POWERMDIENABLED;
            snmp_call_callbacks(SNMP_CALLBACK_APPLICATION,
                    SNMPD_CALLBACK_LLDP,
                    lldp_parms);
            if(lldp_parms->err_val != 0)
            {
                return NULL;
            }
            *var_len = sizeof(long);
            long_ret = (long)lldp_parms->value;
            break;
        case LLDPXDOT3LOCPOWERPAIRCONTROLABLE:
            lldp_parms->group_obj =LLDP_LOCDATA_DOT3POWERPAIRCONTROLABLE;
            snmp_call_callbacks(SNMP_CALLBACK_APPLICATION,
                    SNMPD_CALLBACK_LLDP,
                    lldp_parms);
            if(lldp_parms->err_val != 0)
            {
                return NULL;
            }
            *var_len = sizeof(long);
            long_ret = (long)lldp_parms->value;
            break;
        case LLDPXDOT3LOCPOWERPAIRS:
            lldp_parms->group_obj =LLDP_LOCDATA_DOT3POWERPAIRS;
            snmp_call_callbacks(SNMP_CALLBACK_APPLICATION,
                    SNMPD_CALLBACK_LLDP,
                    lldp_parms);
            if(lldp_parms->err_val != 0)
            {
                return NULL;
            }
            *var_len = sizeof(long);
            long_ret = (long)lldp_parms->value;
            break;
        case LLDPXDOT3LOCPOWERCLASS:
            lldp_parms->group_obj =LLDP_LOCDATA_DOT3POWERCLASS;
            snmp_call_callbacks(SNMP_CALLBACK_APPLICATION,
                    SNMPD_CALLBACK_LLDP,
                    lldp_parms);
            if(lldp_parms->err_val != 0)
            {
                return NULL;
            }
            *var_len = sizeof(long);
            long_ret = (long)lldp_parms->value;
            break;
        default:
            ERROR_MSG("");
            return NULL;
    }
    return (u_char *)&long_ret;
}

/*
 * var_lldpXdot3LocLinkAggTable():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_lldpXdot3MIB above.
 */
unsigned char *
var_lldpXdot3LocLinkAggTable(struct variable *vp,
        oid     *name,
        size_t  *length,
        int     exact,
        size_t  *var_len,
        WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;

    if (!interface_count) {
        interface_parms->group_obj = IF_NUMBER;
        interface_parms->group = GROUP_INTERFACES;
        snmp_call_callbacks(SNMP_CALLBACK_APPLICATION,
                SNMPD_CALLBACK_GROUPS,
                interface_parms);
        interface_count = (int)interface_parms->value;
    }

    /* 
     * This assumes that the table is a 'simple' table.
     *	See the implementation documentation for the meaning of this.
     *	You will need to provide the correct value for the TABLE_SIZE parameter
     *
     * If this table does not meet the requirements for a simple table,
     *	you will need to provide the replacement code yourself.
     *	Mib2c is not smart enough to write this for you.
     *    Again, see the implementation documentation for what is required.
     */
    if (header_simple_table(vp,name,length,exact,var_len,write_method,interface_count)
            == MATCH_FAILED )
        return NULL;
    
    lldp_parms->uport = name[(*length) - 1] - 1;

    /* 
     * this is where we do the value assignments for the mib results.
     */
    lldp_parms->group   =  GROUP_LLDP_DOT3_LOC_SYS;
    lldp_parms->callback_rw = CALLBACK_ACT_READ;
    switch(vp->magic) {
        case LLDPXDOT3LOCLINKAGGSTATUS:
            lldp_parms->group_obj =LLDP_LOCDATA_DOT3LINKAGGSTATUS;
            snmp_call_callbacks(SNMP_CALLBACK_APPLICATION,
                    SNMPD_CALLBACK_LLDP,
                    lldp_parms);
            if(lldp_parms->err_val != 0)
            {
                return NULL;
            }
            *var_len = sizeof(long);
            long_ret = (long)lldp_parms->value;
            break;
        case LLDPXDOT3LOCLINKAGGPORTID:
            lldp_parms->group_obj =LLDP_LOCDATA_DOT3LINKAGGPORTID;
            snmp_call_callbacks(SNMP_CALLBACK_APPLICATION,
                    SNMPD_CALLBACK_LLDP,
                    lldp_parms);
            if(lldp_parms->err_val != 0)
            {
                return NULL;
            }
            *var_len = sizeof(long);
            long_ret = (long)lldp_parms->value;
            break;
        default:
            ERROR_MSG("");
            return NULL;
    }
    return (u_char *)&long_ret;
}

/*
 * var_lldpXdot3LocMaxFrameSizeTable():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_lldpXdot3MIB above.
 */
unsigned char *
var_lldpXdot3LocMaxFrameSizeTable(struct variable *vp,
        oid     *name,
        size_t  *length,
        int     exact,
        size_t  *var_len,
        WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    
    if (!interface_count) {
        interface_parms->group_obj = IF_NUMBER;
        interface_parms->group = GROUP_INTERFACES;
        snmp_call_callbacks(SNMP_CALLBACK_APPLICATION,
                SNMPD_CALLBACK_GROUPS,
                interface_parms);
        interface_count = (int)interface_parms->value;
    }

    /* 
     * This assumes that the table is a 'simple' table.
     *	See the implementation documentation for the meaning of this.
     *	You will need to provide the correct value for the TABLE_SIZE parameter
     *
     * If this table does not meet the requirements for a simple table,
     *	you will need to provide the replacement code yourself.
     *	Mib2c is not smart enough to write this for you.
     *    Again, see the implementation documentation for what is required.
     */
    if (header_simple_table(vp,name,length,exact,var_len,write_method,interface_count)
            == MATCH_FAILED )
        return NULL;
    
    lldp_parms->uport = name[(*length) - 1] - 1;

    /* 
     * this is where we do the value assignments for the mib results.
     */
    lldp_parms->group   =  GROUP_LLDP_DOT3_LOC_SYS;
    lldp_parms->callback_rw = CALLBACK_ACT_READ;
    switch(vp->magic) {
        case LLDPXDOT3LOCMAXFRAMESIZE:
            lldp_parms->group_obj =LLDP_LOCDATA_DOT3MAXFRAMESIZE;
            snmp_call_callbacks(SNMP_CALLBACK_APPLICATION,
                    SNMPD_CALLBACK_LLDP,
                    lldp_parms);
            if(lldp_parms->err_val != 0)
            {
                return NULL;
            }
            *var_len = sizeof(long);
            long_ret = (long)lldp_parms->value;
            break;
        default:
            ERROR_MSG("");
            return NULL;
    }
    return (u_char *)&long_ret;
}

static int 
header_dot3_rem_table(struct variable *vp,
				oid     *name,
				size_t  *length,
				int     exact,
				size_t  *var_length,
				WriteMethod **write_method)
{
#define LLDPREMENTRY_NAME_LENGTH     14 /* 1.0.8802.1.1.2.1.5.4623.1.3.1.1*/
    int found = FALSE, index=0,listIndex=0, result;
    oid newname[MAX_OID_LEN];
    short msap_entry_count;
    char msap_entries[1024];
    int man_addr_count,curr_addr;
    static int timemark=0;
    int newtimemark;
    int new_length=LLDPREMENTRY_NAME_LENGTH;

    lldp_parms->timestamp = timemark;
    lldp_parms->callback_rw = CALLBACK_ACT_READ;
    lldp_parms->group_obj = LLDP_REMDATA_TIMEMARK;
    lldp_parms->group = GROUP_LLDP_REM_SYS;
    /* Callback */
    snmp_call_callbacks(SNMP_CALLBACK_APPLICATION,
            SNMPD_CALLBACK_LLDP,
            lldp_parms);
    if(lldp_parms->err_val != 0)
    {
        return MATCH_FAILED;
    }

    newtimemark = lldp_parms->value;
    msap_entry_count = *(short *)lldp_parms->buf;
    memcpy(msap_entries, &lldp_parms->buf[2], msap_entry_count * 2);

    memcpy((char *)newname,(char *)vp->name,(int)vp->namelen * sizeof(oid));

    for(index=0;index<msap_entry_count;index++)
    {
        new_length = LLDPREMENTRY_NAME_LENGTH;
        newname[new_length++]=timemark;
        newname[new_length++]=(oid)msap_entries[(index*2)] + 1;
        newname[new_length++]=(oid)msap_entries[1+(index*2)] + 1;
        
        result = snmp_oid_compare(name,*length,
                newname,new_length);
        if((exact && (result == 0)) || (!exact && (result < 0)))
        {
            found = TRUE;
            break;
        }
    }
    timemark = newtimemark;

    if(found == FALSE){
        return MATCH_FAILED;
    }

    memcpy((char *)name, (char *)newname, new_length*sizeof(oid));
    *length = new_length;
    *write_method = 0;
    *var_length = sizeof(long);

    return MATCH_SUCCEEDED;
}

/*
 * var_lldpXdot3RemPortTable():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_lldpXdot3MIB above.
 */
unsigned char *
var_lldpXdot3RemPortTable(struct variable *vp,
        oid     *name,
        size_t  *length,
        int     exact,
        size_t  *var_len,
        WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static char buffer[2];

    /* 
     * This assumes that the table is a 'simple' table.
     *	See the implementation documentation for the meaning of this.
     *	You will need to provide the correct value for the TABLE_SIZE parameter
     *
     * If this table does not meet the requirements for a simple table,
     *	you will need to provide the replacement code yourself.
     *	Mib2c is not smart enough to write this for you.
     *    Again, see the implementation documentation for what is required.
     */
    if (header_dot3_rem_table(vp,name,length,exact,var_len,write_method)
            == MATCH_FAILED )
        return NULL;
    
    lldp_parms->timestamp = name[14];
    lldp_parms->uport = name[15] - 1;
    lldp_parms->msap_index = name[16] - 1;

    /* 
     * this is where we do the value assignments for the mib results.
     */
    switch(vp->magic) {
        case LLDPXDOT3REMPORTAUTONEGSUPPORTED:
            lldp_parms->group_obj =LLDP_REMDATA_DOT3PORTAUTONEGSUP;
            break;
        case LLDPXDOT3REMPORTAUTONEGENABLED:
            lldp_parms->group_obj =LLDP_REMDATA_DOT3PORTAUTONEGENABLED;
            break;
        case LLDPXDOT3REMPORTAUTONEGADVERTISEDCAP:
            lldp_parms->group_obj =LLDP_REMDATA_DOT3PORTAUTONEGADVERTISEDCAP;
            lldp_parms->group = GROUP_LLDP_DOT3_REM_SYS;
            lldp_parms->callback_rw = CALLBACK_ACT_READ;
            /* Callback */
            snmp_call_callbacks(SNMP_CALLBACK_APPLICATION,
                    SNMPD_CALLBACK_LLDP,
                    lldp_parms); 
            if(lldp_parms->err_val != 0)
            {
                return NULL;
            }
            *var_len = 2;
            memcpy(buffer,lldp_parms->buf,2);
            return buffer;
            break;
        case LLDPXDOT3REMPORTOPERMAUTYPE:
            lldp_parms->group_obj =LLDP_REMDATA_DOT3PORTOPERMAUTYPE;
            break;
        default:
            ERROR_MSG("");
            return NULL;
    }
    lldp_parms->callback_rw = CALLBACK_ACT_READ;
    lldp_parms->group   =  GROUP_LLDP_DOT3_REM_SYS;
    /* Callback */
    snmp_call_callbacks(SNMP_CALLBACK_APPLICATION,
            SNMPD_CALLBACK_LLDP,
            lldp_parms); 
    if(lldp_parms->err_val != 0)
    {
        return NULL;
    }
    long_ret = (long)lldp_parms->value;
    *var_len = sizeof(long);
    /* Give the value back */
    return (u_char *)&long_ret;
}

/*
 * var_lldpXdot3RemPowerTable():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_lldpXdot3MIB above.
 */
unsigned char *
var_lldpXdot3RemPowerTable(struct variable *vp,
        oid     *name,
        size_t  *length,
        int     exact,
        size_t  *var_len,
        WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;

    /* 
     * This assumes that the table is a 'simple' table.
     *	See the implementation documentation for the meaning of this.
     *	You will need to provide the correct value for the TABLE_SIZE parameter
     *
     * If this table does not meet the requirements for a simple table,
     *	you will need to provide the replacement code yourself.
     *	Mib2c is not smart enough to write this for you.
     *    Again, see the implementation documentation for what is required.
     */
    if (header_dot3_rem_table(vp,name,length,exact,var_len,write_method)
            == MATCH_FAILED )
        return NULL;
    
    lldp_parms->timestamp = name[14];
    lldp_parms->uport = name[15] - 1;
    lldp_parms->msap_index = name[16] - 1;

    /* 
     * this is where we do the value assignments for the mib results.
     */
    switch(vp->magic) {
        case LLDPXDOT3REMPOWERPORTCLASS:
            lldp_parms->group_obj =LLDP_REMDATA_DOT3POWERPORTCLASS;
            break;
        case LLDPXDOT3REMPOWERMDISUPPORTED:
            lldp_parms->group_obj =LLDP_REMDATA_DOT3POWERMDISUP;
            break;
        case LLDPXDOT3REMPOWERMDIENABLED:
            lldp_parms->group_obj =LLDP_REMDATA_DOT3POWERMDIENABLED;
            break;
        case LLDPXDOT3REMPOWERPAIRCONTROLABLE:
            lldp_parms->group_obj =LLDP_REMDATA_DOT3POWERPAIRCONTROLABLE;
            break;
        case LLDPXDOT3REMPOWERPAIRS:
            lldp_parms->group_obj =LLDP_REMDATA_DOT3POWERPAIRS;
            break;
        case LLDPXDOT3REMPOWERCLASS:
            lldp_parms->group_obj =LLDP_REMDATA_DOT3POWERCLASS;
            break;
        default:
            ERROR_MSG("");
            return NULL;
    }

    lldp_parms->callback_rw = CALLBACK_ACT_READ;
    lldp_parms->group   =  GROUP_LLDP_DOT3_REM_SYS;
    snmp_call_callbacks(SNMP_CALLBACK_APPLICATION,
            SNMPD_CALLBACK_LLDP,
            lldp_parms);
    if(lldp_parms->err_val != 0)
    {
        return NULL;
    }
    *var_len = sizeof(long);
    long_ret = (long)lldp_parms->value;
    return (u_char *)&long_ret;
}

/*
 * var_lldpXdot3RemLinkAggTable():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_lldpXdot3MIB above.
 */
unsigned char *
var_lldpXdot3RemLinkAggTable(struct variable *vp,
        oid     *name,
        size_t  *length,
        int     exact,
        size_t  *var_len,
        WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;

    /* 
     * This assumes that the table is a 'simple' table.
     *	See the implementation documentation for the meaning of this.
     *	You will need to provide the correct value for the TABLE_SIZE parameter
     *
     * If this table does not meet the requirements for a simple table,
     *	you will need to provide the replacement code yourself.
     *	Mib2c is not smart enough to write this for you.
     *    Again, see the implementation documentation for what is required.
     */
    if (header_dot3_rem_table(vp,name,length,exact,var_len,write_method)
            == MATCH_FAILED )
        return NULL;

    lldp_parms->timestamp = name[14];
    lldp_parms->uport = name[15] - 1;
    lldp_parms->msap_index = name[16] - 1;

    /* 
     * this is where we do the value assignments for the mib results.
     */
    switch(vp->magic) {
        case LLDPXDOT3REMLINKAGGSTATUS:
            lldp_parms->group_obj =LLDP_REMDATA_DOT3LINKAGGSTATUS;
            break;
        case LLDPXDOT3REMLINKAGGPORTID:
            lldp_parms->group_obj =LLDP_REMDATA_DOT3LINKAGGPORTID;
            break;
        default:
            ERROR_MSG("");
            return NULL;
    }
    lldp_parms->callback_rw = CALLBACK_ACT_READ;
    lldp_parms->group   =  GROUP_LLDP_DOT3_REM_SYS;

    /* Callback */
    snmp_call_callbacks(SNMP_CALLBACK_APPLICATION,
            SNMPD_CALLBACK_LLDP,
            lldp_parms);
    if(lldp_parms->err_val != 0)
    {
        return NULL;
    }

    /* Give the value back */
    long_ret = (long)lldp_parms->value;
    return (u_char *)&long_ret;
}

/*
 * var_lldpXdot3RemMaxFrameSizeTable():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_lldpXdot3MIB above.
 */
unsigned char *
var_lldpXdot3RemMaxFrameSizeTable(struct variable *vp,
        oid     *name,
        size_t  *length,
        int     exact,
        size_t  *var_len,
        WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;

    /* 
     * This assumes that the table is a 'simple' table.
     *	See the implementation documentation for the meaning of this.
     *	You will need to provide the correct value for the TABLE_SIZE parameter
     *
     * If this table does not meet the requirements for a simple table,
     *	you will need to provide the replacement code yourself.
     *	Mib2c is not smart enough to write this for you.
     *    Again, see the implementation documentation for what is required.
     */
    if (header_dot3_rem_table(vp,name,length,exact,var_len,write_method)
            == MATCH_FAILED )
        return NULL;

    lldp_parms->timestamp = name[14];
    lldp_parms->uport = name[15] - 1;
    lldp_parms->msap_index = name[16] - 1;

    /* 
     * this is where we do the value assignments for the mib results.
     */
    switch(vp->magic) {
        case LLDPXDOT3REMMAXFRAMESIZE:
            lldp_parms->group_obj =LLDP_REMDATA_DOT3MAXFRAMESIZE;
            break;
        default:
            ERROR_MSG("");
            return NULL;
    }
    lldp_parms->callback_rw = CALLBACK_ACT_READ;
    lldp_parms->group   =  GROUP_LLDP_DOT3_REM_SYS;

    /* Callback */
    snmp_call_callbacks(SNMP_CALLBACK_APPLICATION,
            SNMPD_CALLBACK_LLDP,
            lldp_parms);
    if(lldp_parms->err_val != 0)
    {
        return NULL;
    }

    /* Give the value back */
    long_ret = (long)lldp_parms->value;
    return (u_char *)&long_ret;
}

int
write_lldpXdot3PortConfigTLVsTxEnable(int      action,
        u_char   *var_val,
        u_char   var_val_type,
        size_t   var_val_len,
        u_char   *statP,
        oid      *name,
        size_t   name_len)
{
    char value;
    int size;

    switch ( action ) {
        case RESERVE1:
            if (var_val_type != ASN_OCTET_STR) {
                LLDP_PRINT("write to lldpXdot3MIB not ASN_OCTET_STR\n");
                return SNMP_ERR_WRONGTYPE;
            }
            if (var_val_len > sizeof(char)) {
                LLDP_PRINT("write to lldpXdot3MIB: bad length\n");
                return SNMP_ERR_WRONGLENGTH;
            }
            break;

        case RESERVE2:
            size  = var_val_len;
            value = * (char *) var_val;
            break;

        case FREE:
            /* Release any resources that have been allocated */
            break;

        case ACTION:
            /*
             * The variable has been stored in 'value' for you to use,
             * and you have just been asked to do something with it.
             * Note that anything done here must be reversable in the UNDO case
             */
            break;

        case UNDO:
            /* Back out any changes made in the ACTION case */
            break;

        case COMMIT:
            /*
             * Things are working well, so it's now safe to make the change
             * permanently.  Make sure that anything done here can't fail!
             */
            value=*(int*)var_val;
            lldp_parms->value = value;
            lldp_parms->group = GROUP_LLDP_DOT3_CONFIG;
            lldp_parms->group_obj = LLDP_CONFIG_DOT3PORTTLVTXENABLE;
            lldp_parms->callback_rw = CALLBACK_ACT_WRITE;

            /* Callback */
            snmp_call_callbacks(SNMP_CALLBACK_APPLICATION,
                    SNMPD_CALLBACK_LLDP,
                    lldp_parms);
            if(lldp_parms->err_val !=0)
            {
                return SNMP_ERR_COMMITFAILED;
            }
            break;
    }
    return SNMP_ERR_NOERROR;
}
