/*
 * $Id: dot1dStp.c,v 1.1 2006/11/23 14:48:41 jeffc Exp $
 */

/* This should always be included first before anything else */
#include <config.h>

/* minimal include directives */
#include "mibincl.h"
#include "mibgroup/util_funcs.h"

#include <ucd-snmp/callback.h>
#include <ucd-snmp/mibgroup/mibII/bridge_mib.h>
#include "mibgroup/mibII/dot1dStp.h"

/* Argument that will be passed for callback function */
static bridge_parameters_t *dot1dStp_params = NULL;

/* Path to this MIB WRT the global MIB tree */
oid dot1dStp_variables_oid[] = { 1,3,6,1,2,1,17,2 };

/* Variables that this MIB supports */
struct variable4 dot1dStp_variables[] = {
/*  magic number        , variable type , ro/rw , callback fn  , L, oidsuffix */
#define DOT1DSTPPROTOCOLSPECIFICATION       1
    {DOT1DSTPPROTOCOLSPECIFICATION,  ASN_INTEGER,  RONLY ,  var_dot1dStp, 1,  { 1 }},
#define DOT1DSTPPRIORITY        2
    {DOT1DSTPPRIORITY,  ASN_INTEGER,  RWRITE,  var_dot1dStp, 1,  { 2 }},
#define DOT1DSTPTIMESINCETOPOLOGYCHANGE     3
    {DOT1DSTPTIMESINCETOPOLOGYCHANGE,  ASN_TIMETICKS,  RONLY ,  var_dot1dStp, 1,  { 3 }},
#define DOT1DSTPTOPCHANGES      4
    {DOT1DSTPTOPCHANGES,  ASN_COUNTER,  RONLY ,  var_dot1dStp, 1,  { 4 }},
#define DOT1DSTPDESIGNATEDROOT      5
    {DOT1DSTPDESIGNATEDROOT,  ASN_OCTET_STR,  RONLY ,  var_dot1dStp, 1,  { 5 }},
#define DOT1DSTPROOTCOST        6
    {DOT1DSTPROOTCOST,  ASN_INTEGER,  RONLY ,  var_dot1dStp, 1,  { 6 }},
#define DOT1DSTPROOTPORT        7
    {DOT1DSTPROOTPORT,  ASN_INTEGER,  RONLY ,  var_dot1dStp, 1,  { 7 }},
#define DOT1DSTPMAXAGE      8
    {DOT1DSTPMAXAGE,  ASN_INTEGER,  RONLY ,  var_dot1dStp, 1,  { 8 }},
#define DOT1DSTPHELLOTIME       9
    {DOT1DSTPHELLOTIME,  ASN_INTEGER,  RONLY ,  var_dot1dStp, 1,  { 9 }},
#define DOT1DSTPHOLDTIME        10
    {DOT1DSTPHOLDTIME,  ASN_INTEGER,  RONLY ,  var_dot1dStp, 1,  { 10 }},
#define DOT1DSTPFORWARDDELAY        11
    {DOT1DSTPFORWARDDELAY,  ASN_INTEGER,  RONLY ,  var_dot1dStp, 1,  { 11 }},
#define DOT1DSTPBRIDGEMAXAGE        12
    {DOT1DSTPBRIDGEMAXAGE,  ASN_INTEGER,  RWRITE,  var_dot1dStp, 1,  { 12 }},
#define DOT1DSTPBRIDGEHELLOTIME     13
    {DOT1DSTPBRIDGEHELLOTIME,  ASN_INTEGER,  RWRITE,  var_dot1dStp, 1,  { 13 }},
#define DOT1DSTPBRIDGEFORWARDDELAY      14
    {DOT1DSTPBRIDGEFORWARDDELAY,  ASN_INTEGER,  RWRITE,  var_dot1dStp, 1,  { 14 }},
#define DOT1DSTPPORT        15
    {DOT1DSTPPORT,  ASN_INTEGER,  RONLY,   var_dot1dStpPortTable, 3,  { 15, 1, 1 }},
#define DOT1DSTPPORTPRIORITY        16
    {DOT1DSTPPORTPRIORITY,  ASN_INTEGER,  RWRITE,  var_dot1dStpPortTable, 3,  { 15, 1, 2 }},
#define DOT1DSTPPORTSTATE       17
    {DOT1DSTPPORTSTATE,  ASN_INTEGER,  RONLY,   var_dot1dStpPortTable, 3,  { 15, 1, 3 }},
#define DOT1DSTPPORTENABLE      18
    {DOT1DSTPPORTENABLE,  ASN_INTEGER,  RWRITE,  var_dot1dStpPortTable, 3,  { 15, 1, 4 }},
#define DOT1DSTPPORTPATHCOST        19
    {DOT1DSTPPORTPATHCOST,  ASN_INTEGER,  RWRITE,  var_dot1dStpPortTable, 3,  { 15, 1, 5 }},
#define DOT1DSTPPORTDESIGNATEDROOT      20
    {DOT1DSTPPORTDESIGNATEDROOT,  ASN_OCTET_STR,  RONLY,   var_dot1dStpPortTable, 3,  { 15, 1, 6 }},
#define DOT1DSTPPORTDESIGNATEDCOST      21
    {DOT1DSTPPORTDESIGNATEDCOST,  ASN_INTEGER,  RONLY,   var_dot1dStpPortTable, 3,  { 15, 1, 7 }},
#define DOT1DSTPPORTDESIGNATEDBRIDGE        22
    {DOT1DSTPPORTDESIGNATEDBRIDGE,  ASN_OCTET_STR,  RONLY,   var_dot1dStpPortTable, 3,  { 15, 1, 8 }},
#define DOT1DSTPPORTDESIGNATEDPORT      23
    {DOT1DSTPPORTDESIGNATEDPORT,  ASN_OCTET_STR,  RONLY,   var_dot1dStpPortTable, 3,  { 15, 1, 9 }},
#define DOT1DSTPPORTFORWARDTRANSITIONS      24
    {DOT1DSTPPORTFORWARDTRANSITIONS,  ASN_COUNTER,  RONLY,   var_dot1dStpPortTable, 3,  { 15, 1, 10 }},
#define DOT1DSTPVERSION     25
    {DOT1DSTPVERSION, ASN_INTEGER, RWRITE, var_dot1dStp, 1, {16}},
#define DOT1DSTPTXHOLDCOUNT     26
    {DOT1DSTPTXHOLDCOUNT, ASN_INTEGER, RWRITE, var_dot1dStp, 1, {17}},
#define DOT1DSTPPATHCOSTDEFAULT     27
    {DOT1DSTPPATHCOSTDEFAULT, ASN_INTEGER, RWRITE, var_dot1dStp, 1, {18}},
#define DOT1DSTPPORTPROTOCOLMIGRATION       28
    {DOT1DSTPPORTPROTOCOLMIGRATION, ASN_INTEGER, RWRITE, var_dot1dStpExtPortTable, 3, {19, 1, 1}},
#define DOT1DSTPPORTADMINEDGEPORT       29
    {DOT1DSTPPORTADMINEDGEPORT, ASN_INTEGER, RWRITE, var_dot1dStpExtPortTable, 3, {19, 1, 2}},
#define DOT1DSTPPORTOPEREDGEPORT        30
    {DOT1DSTPPORTOPEREDGEPORT, ASN_INTEGER, RONLY, var_dot1dStpExtPortTable, 3, {19, 1, 3}},
#define DOT1DSTPPORTADMINPOINTTOPOINT       31
    {DOT1DSTPPORTADMINPOINTTOPOINT, ASN_INTEGER, RWRITE, var_dot1dStpExtPortTable, 3, {19, 1, 4}},
#define DOT1DSTPPORTOPERPOINTTOPOINT        32
    {DOT1DSTPPORTOPERPOINTTOPOINT, ASN_INTEGER, RONLY, var_dot1dStpExtPortTable, 3, {19, 1, 5}},
#define DOT1DSTPPORTADMINPATHCOST       33
    {DOT1DSTPPORTADMINPATHCOST, ASN_INTEGER, RWRITE, var_dot1dStpExtPortTable, 3, {19, 1, 6}},
};

/** Initializes the dot1dStp module */
void
init_dot1dStp(void)
{
    AGENT_ENTER;

    /* Allocate memory */
    dot1dStp_params = (bridge_parameters_t *) \
                sal_alloc(sizeof(bridge_parameters_t),MIBII_DOT1DSTP_MIB);

    if (dot1dStp_params != NULL) {
        /* register ourselves with the agent to handle our mib tree */
        REGISTER_MIB(MIBII_DOT1DSTP_MIB, dot1dStp_variables, variable4,
                     dot1dStp_variables_oid);

        memset (dot1dStp_params, 0, sizeof(bridge_parameters_t));
        dot1dStp_params->group = BRIDGE_DOT1DSTP;
    }
    
    AGENT_EXIT;
}

/*
 * var_dot1dStp():
 */
unsigned char *
var_dot1dStp(struct variable *vp,
                oid     *name,
                size_t  *length,
                int     exact,
                size_t  *var_len,
                WriteMethod **write_method)
{
    AGENT_ENTER;
    static long long_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    
    if (header_generic(vp,name,length,exact,var_len,write_method)
                                               == MATCH_FAILED ) {
        AGENT_EXIT;
        return NULL;
    }

    /* We will have a common write method */
    *write_method = write_dot1dStp;

    switch(vp->magic) {
        case DOT1DSTPPROTOCOLSPECIFICATION:
            dot1dStp_params->group_obj = DOT1D_STPPROTOCOLSPECIFICATION;
            break;
            
        case DOT1DSTPPRIORITY:
            dot1dStp_params->group_obj = DOT1D_STPPRIORITY;
            break;
        
        case DOT1DSTPTIMESINCETOPOLOGYCHANGE:
            dot1dStp_params->group_obj = DOT1D_STPTIMESINCETOPOLOGYCHANGE;
            break;
            
        case DOT1DSTPTOPCHANGES:
            dot1dStp_params->group_obj = DOT1D_STPTOPCHANGES;
            break;
            
        case DOT1DSTPDESIGNATEDROOT:
            dot1dStp_params->group_obj = DOT1D_STPDESIGNATEDROOT;
            break;
            
        case DOT1DSTPROOTCOST:
            dot1dStp_params->group_obj = DOT1D_STPROOTCOST;
            break;
            
        case DOT1DSTPROOTPORT:
            dot1dStp_params->group_obj = DOT1D_STPROOTPORT;
            break;
            
        case DOT1DSTPMAXAGE:
            dot1dStp_params->group_obj = DOT1D_STPMAXAGE;
            break;
            
        case DOT1DSTPHELLOTIME:
            dot1dStp_params->group_obj = DOT1D_STPHELLOTIME;
            break;
            
        case DOT1DSTPHOLDTIME:
            dot1dStp_params->group_obj = DOT1D_STPHOLDTIME;
            break;
            
        case DOT1DSTPFORWARDDELAY:
            dot1dStp_params->group_obj = DOT1D_STPFORWARDDELAY;
            break;
            
        case DOT1DSTPBRIDGEMAXAGE:
            dot1dStp_params->group_obj = DOT1D_STPBRIDGEMAXAGE;
            break;
            
        case DOT1DSTPBRIDGEHELLOTIME:
            dot1dStp_params->group_obj = DOT1D_STPBRIDGEHELLOTIME;
            break;
            
        case DOT1DSTPBRIDGEFORWARDDELAY:
            dot1dStp_params->group_obj = DOT1D_STPBRIDGEFORWARDDELAY;
            break;
            
        case DOT1DSTPVERSION:
            dot1dStp_params->group_obj = DOT1D_STPVERSION;
            break;
            
        case DOT1DSTPTXHOLDCOUNT:
            dot1dStp_params->group_obj = DOT1D_STPTXHOLDCOUNT;
            break;
            
        case DOT1DSTPPATHCOSTDEFAULT:
            dot1dStp_params->group_obj = DOT1D_STPPATHCOSTDEFAULT;
            break;
            
        default:
            ERROR_MSG("Undefined MIB Reference in dot1dStp");
            AGENT_EXIT;
            return NULL;
    }

    /* Callback */
    dot1dStp_params->callback_rw = CALLBACK_ACT_READ;
    snmp_call_callbacks(SNMP_CALLBACK_APPLICATION,
                        SNMPD_CALLBACK_BRIDGE,
                        dot1dStp_params);

    /* Give the value back */
    switch (vp->magic) {
    case DOT1DSTPDESIGNATEDROOT:
        *var_len =  dot1dStp_params->value;
        if (*var_len == 0) {
            *var_len = C_BRIDGE_ROOT_LEN;
            memset (string, 0, *var_len);
        } else {
            memcpy(string, dot1dStp_params->buf, *var_len);
        }
        AGENT_EXIT;
        return (unsigned char *) string;
    }

    long_ret = (long)dot1dStp_params->value;
    AGENT_EXIT;
    return (unsigned char *)&long_ret;
}

static int
header_dot1dStpPortEntry(struct variable *vp,
           oid *name,
           size_t *length,
           int exact,
           size_t *var_len,
           WriteMethod **write_method)
{
#define DOT1DSTPPORTENTRY_NAME_LENGTH   11
    AGENT_ENTER;
    oid newname[MAX_OID_LEN];
    int i, result;
    int port_number;
    int found = FALSE;

    memcpy( (char *)newname,(char *)vp->name, (int)vp->namelen * sizeof(oid));

    for(i = 1; i <= interface_count; i++) {
        newname[DOT1DSTPPORTENTRY_NAME_LENGTH] = (oid)i ;
        result = snmp_oid_compare(name, *length, newname, 
                                  (int)vp->namelen + 1);
        if ((exact && (result == 0)) || (!exact && (result < 0))) {
            found = TRUE;
            port_number = i;
            break;
        }
    }

    /* TODO: Get AGG Port info? */
    if ( found == FALSE ) {
        AGENT_EXIT;
        return MATCH_FAILED;
    }

    memcpy( (char *)name,(char *)newname, ((int)vp->namelen + 1) * sizeof(oid));
    *length = vp->namelen + 1;

    /* No create, so set the write method here */
    *write_method = write_dot1dStpPortTableEntry;
    
    *var_len = sizeof(long);
    AGENT_EXIT;
    return port_number;
}

/*
 * var_dot1dStpPortTable():
 *  This function contains Multi-Index tables
 */
unsigned char *
var_dot1dStpPortTable(struct variable *vp,
            oid     *name,
            size_t  *length,
            int     exact,
            size_t  *var_len,
            WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static unsigned char string[SPRINT_MAX_LEN];

    /* Validate first */
    snmp_mib_setInterfaceCount();
    if ((dot1dStp_params->index = header_dot1dStpPortEntry(vp,name,length,exact,
                            var_len,write_method)) == MATCH_FAILED ) {
        AGENT_EXIT;
        return NULL;
    }
    AGENT_DBG(("Port number is %d", dot1dStp_params->index));
    switch(vp->magic) {
        case DOT1DSTPPORT:
            dot1dStp_params->group_obj = DOT1D_STPPORT;
            break;
            
        case DOT1DSTPPORTPRIORITY:
            dot1dStp_params->group_obj = DOT1D_STPPORTPRIORITY;
            break;
            
        case DOT1DSTPPORTSTATE:
            dot1dStp_params->group_obj = DOT1D_STPPORTSTATE;
            break;
            
        case DOT1DSTPPORTENABLE:
            dot1dStp_params->group_obj = DOT1D_STPPORTENABLE;
            break;
            
        case DOT1DSTPPORTPATHCOST:
            dot1dStp_params->group_obj = DOT1D_STPPORTPATHCOST;
            break;
            
        case DOT1DSTPPORTDESIGNATEDROOT:
            dot1dStp_params->group_obj = DOT1D_STPPORTDESIGNATEDROOT;
            break;
            
        case DOT1DSTPPORTDESIGNATEDCOST:
            dot1dStp_params->group_obj = DOT1D_STPPORTDESIGNATEDCOST;
            break;
            
        case DOT1DSTPPORTDESIGNATEDBRIDGE:
            dot1dStp_params->group_obj = DOT1D_STPPORTDESIGNATEDBRIDGE;
            break;
            
        case DOT1DSTPPORTDESIGNATEDPORT:
            dot1dStp_params->group_obj = DOT1D_STPPORTDESIGNATEDPORT;
            break;
            
        case DOT1DSTPPORTFORWARDTRANSITIONS:
            dot1dStp_params->group_obj = DOT1D_STPPORTFORWARDTRANSITIONS;
            break;
            
        default:
            ERROR_MSG("Undefined DOT1D Port MIb reference");
            AGENT_EXIT;
            return NULL;
    }

    /* Callback */
    dot1dStp_params->callback_rw = CALLBACK_ACT_READ;
    snmp_call_callbacks(SNMP_CALLBACK_APPLICATION,
                        SNMPD_CALLBACK_BRIDGE,
                        dot1dStp_params);

    /* Give values back */
    switch (vp->magic) {
        case DOT1DSTPPORTDESIGNATEDBRIDGE:
        case DOT1DSTPPORTDESIGNATEDROOT:
        case DOT1DSTPPORTDESIGNATEDPORT:
            *var_len =  dot1dStp_params->value; 
            memcpy(string, dot1dStp_params->buf, *var_len);
            return (unsigned char *) string;
    }

    long_ret = (long)dot1dStp_params->value;
    return (unsigned char *)&long_ret;
}

static int
header_dot1dStpExtPortEntry(struct variable *vp,
           oid *name,
           size_t *length,
           int exact,
           size_t *var_len,
           WriteMethod **write_method)
{
#define DOT1DSTPEXTPORTENTRY_NAME_LENGTH    11
    AGENT_ENTER;
    oid newname[MAX_OID_LEN];
    int i, result;
    int port_number;
    int found = FALSE;

    memcpy( (char *)newname,(char *)vp->name, (int)vp->namelen * sizeof(oid));

    for(i = 1; i <= interface_count; i++) {
        newname[DOT1DSTPPORTENTRY_NAME_LENGTH] = (oid)i ;
        result = snmp_oid_compare(name, *length, newname, 
                                  (int)vp->namelen + 1);
        if ((exact && (result == 0)) || (!exact && (result < 0))) {
            found = TRUE;
            port_number = i;
            break;
        }
    }

    /* TODO: Get AGG Port info? */
    if (found == FALSE) {
        AGENT_EXIT;
        return MATCH_FAILED;
    }

    memcpy( (char *)name,(char *)newname, ((int)vp->namelen + 1) * sizeof(oid));
    *length = vp->namelen + 1;

    /* Set the write method here */
    *write_method = write_dot1dStpExtPortTableEntry;
    *var_len = sizeof(long);    /* default to 'long' results */

    AGENT_EXIT;
    return port_number;
}

/*
 * var_dot1dStpExtPortTable():
 */
unsigned char  *
var_dot1dStpExtPortTable(struct variable *vp,
                         oid * name,
                         size_t * length,
                         int exact,
                         size_t * var_len, WriteMethod ** write_method)
{
    AGENT_ENTER;
    static long     long_ret;

    snmp_mib_setInterfaceCount();
    if ((dot1dStp_params->index = header_dot1dStpExtPortEntry
                    (vp, name, length, exact, var_len, write_method))
                                                        == MATCH_FAILED) {
        AGENT_EXIT;
        return NULL;
    }

    AGENT_DBG(("Port number is %d", dot1dStp_params->index));
    switch (vp->magic) {
        case DOT1DSTPPORTPROTOCOLMIGRATION:
            dot1dStp_params->group_obj = DOT1D_STPPORTPROTOCOLMIGRATION;
            break;
        case DOT1DSTPPORTADMINEDGEPORT:
            dot1dStp_params->group_obj = DOT1D_STPPORTADMINEDGEPORT;
            break;
        case DOT1DSTPPORTOPEREDGEPORT:
            dot1dStp_params->group_obj = DOT1D_STPPORTOPEREDGEPORT;
            break;
        case DOT1DSTPPORTADMINPOINTTOPOINT:
            dot1dStp_params->group_obj = DOT1D_STPPORTADMINPOINTTOPOINT;
            break;
        case DOT1DSTPPORTOPERPOINTTOPOINT:
            dot1dStp_params->group_obj = DOT1D_STPPORTOPERPOINTTOPOINT;
            break;
        case DOT1DSTPPORTADMINPATHCOST:
            dot1dStp_params->group_obj = DOT1D_STPPORTADMINPATHCOST;
            break;
        default:
            ERROR_MSG("Unknown managed object");
            AGENT_EXIT;
            return NULL;
    }

    dot1dStp_params->callback_rw = CALLBACK_ACT_READ;
    snmp_call_callbacks(SNMP_CALLBACK_APPLICATION,
                        SNMPD_CALLBACK_BRIDGE,
                        dot1dStp_params);

    long_ret = (long)dot1dStp_params->value;
    return (unsigned char *)&long_ret;
}

int
write_dot1dStp(int action,
                       u_char * var_val,
                       u_char var_val_type,
                       size_t var_val_len,
                       u_char * statP, oid * name, size_t name_len)
{
#define C_VAR_OFFSET          9
#define C_OFFSET_VAR_START   16
    long            value = 0;
    int             size;

    int var;
    var = name[8];

    if (var >= C_OFFSET_VAR_START) {
        var += C_VAR_OFFSET; /* Version = 25 here */
    }

    if (var_val) {
        value = * (long *) var_val;
    }

    AGENT_DBG(("Function %s, var %d", __FUNCTION__, var));
    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_INTEGER) {
            fprintf(stderr, "write to dot1dStp not ASN_INTEGER\n");
            return SNMP_ERR_WRONGTYPE;
        }

        if (var_val_len > sizeof(long)) {
            fprintf(stderr, "write to dot1dStp: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }
        switch(var) {
            case DOT1DSTPPRIORITY:
                if (value < 0 || value > C_STP_PRIORITY_MAX 
                                ||value & C_STP_PRIORITY_MASK) {
                    return SNMP_ERR_WRONGVALUE;
                }
                break;

            case DOT1DSTPBRIDGEMAXAGE:
                if (value < C_BRIDGE_MIN_MAXAGE || value > C_BRIDGE_MAX_MAXAGE 
                                                        || (value%100 != 0)) {
                    return SNMP_ERR_WRONGVALUE;
                }
                break;

            case DOT1DSTPBRIDGEHELLOTIME:
                if (value < C_BRIDGE_MIN_HELLOTIME || 
                        value > C_BRIDGE_MAX_HELLOTIME || 
                        (value%100 != 0)) {
                    return SNMP_ERR_WRONGVALUE;
                }
                break;
            case DOT1DSTPBRIDGEFORWARDDELAY:
                if (value < C_BRIDGE_MIN_FWDELAY || 
                        value > C_BRIDGE_MAX_FWDELAY || (value%100 != 0)) {
                    return SNMP_ERR_WRONGVALUE;
                }
                break;
            case DOT1DSTPVERSION:
                if (value != C_BRIDGE_STPVER_STPCOMPAT && 
                            value != C_BRIDGE_STPVER_RSTP) {
                    return SNMP_ERR_WRONGVALUE;
                }
                break;
            case DOT1DSTPTXHOLDCOUNT:
                if (value < C_STP_TXHOLDCNT_MIN || 
                            value > C_STP_TXHOLDCNT_MAX) {
                    return SNMP_ERR_WRONGVALUE;
                }
                break;
            case DOT1DSTPPATHCOSTDEFAULT:
                if (value != C_STP_PCOST_1998 && 
                        value != C_STP_PCOST_2001) {
                    return SNMP_ERR_WRONGVALUE;
                }
               break;
            default:
                return SNMP_ERR_NOTWRITABLE;
        }
        break;

    case RESERVE2:
        break;

    case FREE:
       break;

    case ACTION:
        break;

    case UNDO:
        break;

    case COMMIT:
        switch(var) {
            case DOT1DSTPPRIORITY:
                dot1dStp_params->value = value;
                dot1dStp_params->group_obj = DOT1D_STPPRIORITY;
                break;
            case DOT1DSTPBRIDGEMAXAGE:
                dot1dStp_params->value = value/100;
                dot1dStp_params->group_obj = DOT1D_STPBRIDGEMAXAGE;
                break;
            case DOT1DSTPBRIDGEHELLOTIME:
                dot1dStp_params->value = value/100;
                dot1dStp_params->group_obj = DOT1D_STPBRIDGEHELLOTIME;
                break;
            case DOT1DSTPBRIDGEFORWARDDELAY:
                dot1dStp_params->value = value/100;
                dot1dStp_params->group_obj = DOT1D_STPBRIDGEFORWARDDELAY;
                break;
            case DOT1DSTPVERSION:
                dot1dStp_params->value = value;
                dot1dStp_params->group_obj = DOT1D_STPVERSION;
                break;
            case DOT1DSTPTXHOLDCOUNT:
                dot1dStp_params->value = value;
                dot1dStp_params->group_obj = DOT1D_STPTXHOLDCOUNT;
                break;
            case DOT1DSTPPATHCOSTDEFAULT:
                dot1dStp_params->value = value;
                dot1dStp_params->group_obj = DOT1D_STPPATHCOSTDEFAULT;
               break;
            default:
                return SNMP_ERR_NOTWRITABLE;
        }

        /* We have already filled enough information. Let us commit */
        dot1dStp_params->callback_rw = CALLBACK_ACT_WRITE;
        snmp_call_callbacks(SNMP_CALLBACK_APPLICATION, 
                            SNMPD_CALLBACK_BRIDGE,
                            dot1dStp_params);
        if (dot1dStp_params->rv == MIB_STATUS_ERROR) {
            AGENT_EXIT;
            return SNMP_ERR_COMMITFAILED;
        }
        break;
    }
    return SNMP_ERR_NOERROR;
}

int
write_dot1dStpPortTableEntry(int action,
                           u_char * var_val,
                           u_char var_val_type,
                           size_t var_val_len,
                           u_char * statP, oid * name, size_t name_len)
{
    long            value = 0;
    int             size;
    int var;
    /* 
     * the port table entries are registered starting from 15, whereas the
     * index starts from 1 
     */
    var = name[DOT1DSTPPORTENTRY_NAME_LENGTH-1] + 14;
    if (var_val) {
        value = * (long *) var_val;
    }

    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_INTEGER) {
            fprintf(stderr, "write to dot1dStp not ASN_INTEGER\n");
            return SNMP_ERR_WRONGTYPE;
        }

        if (var_val_len > sizeof(long)) {
            fprintf(stderr, "write to dot1dStp: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }
        switch(var) {
            case DOT1DSTPPORTPRIORITY:      
                if (value < 0 || value > C_STP_PORTPRIO_MAX
                                            || value & 0xf) {
                    return SNMP_ERR_WRONGVALUE;
                }
                break;
            case DOT1DSTPPORTENABLE:
                if (value != MIB_STATUS_ENABLED && 
                                value != MIB_STATUS_DISABLED) {
                    return SNMP_ERR_WRONGVALUE;
                }
                break;
            case DOT1DSTPPORTPATHCOST:
                if (value < 1 || value > C_STP_PATHCOST_MAX) {
                    return SNMP_ERR_WRONGVALUE;
                }
                break;
            default:
                DEBUGMSGTL(("dot1dStp", "Write to unknown object\n"));
                return SNMP_ERR_NOTWRITABLE;
        }

        break;

    case RESERVE2:
        break;

    case FREE:
        break;

    case ACTION:
        break;

    case UNDO:
        /*
         * Back out any changes made in the ACTION case 
         */
        break;

    case COMMIT:
        switch(var) {
            case DOT1DSTPPORTPRIORITY:      
                dot1dStp_params->value = value;
                dot1dStp_params->group_obj = DOT1D_STPPORTPRIORITY;
                break;
            case DOT1DSTPPORTPATHCOST:
                dot1dStp_params->value = value;
                dot1dStp_params->group_obj = DOT1D_STPPORTPATHCOST;
                break;
            case DOT1DSTPPORTENABLE:
                dot1dStp_params->value = value;
                dot1dStp_params->group_obj = DOT1D_STPPORTENABLE;
                break;
            default:
                DEBUGMSGTL(("dot1dStp", "Write to unknown object\n"));
                return SNMP_ERR_NOTWRITABLE;
        }

        /* We have already filled enough information. Let us commit */
        dot1dStp_params->callback_rw = CALLBACK_ACT_WRITE;
        snmp_call_callbacks(SNMP_CALLBACK_APPLICATION, 
                            SNMPD_CALLBACK_BRIDGE,
                            dot1dStp_params);
        if (dot1dStp_params->rv == MIB_STATUS_ERROR) {
            AGENT_EXIT;
            return SNMP_ERR_COMMITFAILED;
        }
        break;
    }
    return SNMP_ERR_NOERROR;
}

int
write_dot1dStpExtPortTableEntry(int action,
                                    u_char * var_val,
                                    u_char var_val_type,
                                    size_t var_val_len,
                                    u_char * statP,
                                    oid * name, size_t name_len)
{
    long            value;
    int             size;
    int var;

    /* registration of Ext table entries start at 28 */
    var = name[DOT1DSTPEXTPORTENTRY_NAME_LENGTH-1] + 27;
    if (var_val) {
        value = *(long *) var_val;
    }

    switch (action) {
    case RESERVE1:
        if (var_val_type != ASN_INTEGER) {
            fprintf(stderr, "write to dot1dStp not ASN_INTEGER\n");
            return SNMP_ERR_WRONGTYPE;
        }
        if (var_val_len > sizeof(long)) {
            fprintf(stderr, "write to dot1dStp: bad length\n");
            return SNMP_ERR_WRONGLENGTH;
        }

        switch (var) {
        case DOT1DSTPPORTPROTOCOLMIGRATION:
            if (value != MIB_STATUS_ENABLED &&
                    value != MIB_STATUS_DISABLED) {
                return SNMP_ERR_WRONGVALUE;
            }
            break;
        case DOT1DSTPPORTADMINEDGEPORT:
            if (value != MIB_STATUS_ENABLED && 
                    value != MIB_STATUS_DISABLED) {
                return SNMP_ERR_WRONGVALUE;
            }
            break;
        case DOT1DSTPPORTADMINPOINTTOPOINT:
            if (value < C_STP_ADMINP2P_TRUE || 
                    value > C_STP_ADMINP2P_AUTO) {
                return SNMP_ERR_WRONGVALUE;
            }
            break;
        case DOT1DSTPPORTADMINPATHCOST:
            if (value < 0 || value > C_STP_PATHCOST_MAX) {
                return SNMP_ERR_WRONGVALUE;
            }
            break;
        default:
            ERROR_MSG("Unknown managed object");
            return SNMP_ERR_NOTWRITABLE;
        }
        break;

    case RESERVE2:
        break;

    case FREE:
        /*
         * Release any resources that have been allocated 
         */
        break;

    case ACTION:
       
        break;

    case UNDO:
        /*
         * Back out any changes made in the ACTION case 
         */
        break;
    case COMMIT:
        switch (var) {
            case DOT1DSTPPORTPROTOCOLMIGRATION:
                dot1dStp_params->group_obj = DOT1D_STPPORTPROTOCOLMIGRATION;
                dot1dStp_params->value = value;
                break;
            case DOT1DSTPPORTADMINEDGEPORT:
                dot1dStp_params->group_obj = DOT1D_STPPORTADMINEDGEPORT;
                dot1dStp_params->value = value;
                break;
            case DOT1DSTPPORTADMINPOINTTOPOINT:
                dot1dStp_params->value = value;
                dot1dStp_params->group_obj = DOT1D_STPPORTADMINPOINTTOPOINT;
                break;
            case DOT1DSTPPORTADMINPATHCOST:
                dot1dStp_params->group_obj = DOT1D_STPPORTADMINPATHCOST;
                dot1dStp_params->value = value;
                break;
            default:
                ERROR_MSG("Unknown managed object");
                return SNMP_ERR_NOTWRITABLE;
        }

        dot1dStp_params->callback_rw = CALLBACK_ACT_WRITE;
        snmp_call_callbacks(SNMP_CALLBACK_APPLICATION, 
                            SNMPD_CALLBACK_BRIDGE,
                            dot1dStp_params);
        if (dot1dStp_params->rv == MIB_STATUS_ERROR) {
            AGENT_EXIT;
            return SNMP_ERR_COMMITFAILED;
        }
        break;
    }

    return SNMP_ERR_NOERROR;
}

