//==========================================================================
//
//      snmp/snmpagent/current/src/mibgroup/mibII/interfaces.c
//
//
//==========================================================================
//####ECOSGPLCOPYRIGHTBEGIN####
// -------------------------------------------
// This file is part of eCos, the Embedded Configurable Operating System.
// Copyright (C) 1998, 1999, 2000, 2001, 2002 Red Hat, Inc.
//
// eCos is free software; you can redistribute it and/or modify it under
// the terms of the GNU General Public License as published by the Free
// Software Foundation; either version 2 or (at your option) any later version.
//
// eCos is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or
// FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
// for more details.
//
// You should have received a copy of the GNU General Public License along
// with eCos; if not, write to the Free Software Foundation, Inc.,
// 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
//
// As a special exception, if other files instantiate templates or use macros
// or inline functions from this file, or you compile this file and link it
// with other works to produce a work based on this file, this file does not
// by itself cause the resulting work to be covered by the GNU General Public
// License. However the source code for this file must still be made available
// in accordance with section (3) of the GNU General Public License.
//
// This exception does not invalidate any other reasons why a work based on
// this file might be covered by the GNU General Public License.
//
// Alternative licenses for eCos may be arranged by contacting Red Hat, Inc.
// at http://sources.redhat.com/ecos/ecos-license/
// -------------------------------------------
//####ECOSGPLCOPYRIGHTEND####
//####UCDSNMPCOPYRIGHTBEGIN####
//
// -------------------------------------------
//
// Portions of this software may have been derived from the UCD-SNMP
// project,  <http://ucd-snmp.ucdavis.edu/>  from the University of
// California at Davis, which was originally based on the Carnegie Mellon
// University SNMP implementation.  Portions of this software are therefore
// covered by the appropriate copyright disclaimers included herein.
//
// The release used was version 4.1.2 of May 2000.  "ucd-snmp-4.1.2"
// -------------------------------------------
//
//####UCDSNMPCOPYRIGHTEND####
//==========================================================================
//#####DESCRIPTIONBEGIN####
//
// Author(s):    hmt
// Contributors: hmt, Andrew Lunn
// Date:         2000-05-30
// Purpose:      Port of UCD-SNMP distribution to eCos.
// Description:  
//              
//
//####DESCRIPTIONEND####
//
//==========================================================================
/********************************************************************
       Copyright 1989, 1991, 1992 by Carnegie Mellon University
 
                          Derivative Work -
Copyright 1996, 1998, 1999, 2000 The Regents of the University of California
 
                         All Rights Reserved
 
Permission to use, copy, modify and distribute this software and its
documentation for any purpose and without fee is hereby granted,
provided that the above copyright notice appears in all copies and
that both that copyright notice and this permission notice appear in
supporting documentation, and that the name of CMU and The Regents of
the University of California not be used in advertising or publicity
pertaining to distribution of the software without specific written
permission.
 
CMU AND THE REGENTS OF THE UNIVERSITY OF CALIFORNIA DISCLAIM ALL
WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS.  IN NO EVENT SHALL CMU OR
THE REGENTS OF THE UNIVERSITY OF CALIFORNIA BE LIABLE FOR ANY SPECIAL,
INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING
FROM THE LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF
CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*********************************************************************/
/* This file was generated by mib2c and is intended for use as a mib module
   for the ucd-snmp snmpd agent. */

#include <pkgconf/system.h>

#include <sys/param.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <net/if.h>
#ifdef CYGPKG_NET_FREEBSD_STACK
#include <net/if_var.h>
#endif
#include <netinet/in.h>
#include <netinet/if_ether.h>
#include <net/if_arp.h>
// These two to acquire all the statistics.

#include <cyg/io/eth/eth_drv_stats.h>
#include <sys/sockio.h>

/* This should always be included first before anything else */
#include <config.h>


/* minimal include directives */
#include "mibincl.h"
#include "mibgroup/util_funcs.h"
#include "mibgroup/mibII/interfaces.h"
#include "mibgroup/mibII/ifr_helper.h"
#include <net/if_types.h>


/* BCM support: implement MIB II groups */
#include <ucd-snmp/callback.h>
#include "mibgroup/mibII/group_mib.h"

extern struct timeval starttime;
static group_parameters_t *interface_parms = NULL;
static long interface_lastchange[MAX_INTERFACE_NUM];
/* END: implement MIB II groups */

/* 
 * interfaces_variables_oid:
 *   this is the top level oid that we want to register under.  This
 *   is essentially a prefix, with the suffix appearing in the
 *   variable below.
 */
oid interfaces_variables_oid[] = { 1,3,6,1,2,1,2 };


/* 
 * variable4 interfaces_variables:
 *   this variable defines function callbacks and type return information 
 *   for the interfaces mib section 
 */


struct variable4 interfaces_variables[] = {
/*  magic number        , variable type , ro/rw , callback fn  , L, oidsuffix */
#define   IFNUMBER              1
  { IFNUMBER            , ASN_INTEGER   , RONLY , var_interfaces, 1, { 1 } },
#define   IFINDEX               4
  { IFINDEX             , ASN_INTEGER   , RONLY , var_ifTable, 3, { 2,1,1 } },
#define   IFDESCR               5
  { IFDESCR             , ASN_OCTET_STR , RONLY , var_ifTable, 3, { 2,1,2 } },
#define   IFTYPE                6
  { IFTYPE              , ASN_INTEGER   , RONLY , var_ifTable, 3, { 2,1,3 } },
#define   IFMTU                 7
  { IFMTU               , ASN_INTEGER   , RONLY , var_ifTable, 3, { 2,1,4 } },
#define   IFSPEED               8
  { IFSPEED             , ASN_GAUGE     , RONLY , var_ifTable, 3, { 2,1,5 } },
#define   IFPHYSADDRESS         9
  { IFPHYSADDRESS       , ASN_OCTET_STR , RONLY , var_ifTable, 3, { 2,1,6 } },
#define   IFADMINSTATUS         10
  { IFADMINSTATUS       , ASN_INTEGER   , RWRITE, var_ifTable, 3, { 2,1,7 } },
#define   IFOPERSTATUS          11
  { IFOPERSTATUS        , ASN_INTEGER   , RONLY , var_ifTable, 3, { 2,1,8 } },
#define   IFLASTCHANGE          12
  { IFLASTCHANGE        , ASN_TIMETICKS , RONLY , var_ifTable, 3, { 2,1,9 } },
#define   IFINOCTETS            13
  { IFINOCTETS          , ASN_COUNTER   , RONLY , var_ifTable, 3, { 2,1,10 } },
#define   IFINUCASTPKTS         14
  { IFINUCASTPKTS       , ASN_COUNTER   , RONLY , var_ifTable, 3, { 2,1,11 } },
#define   IFINNUCASTPKTS        15
  { IFINNUCASTPKTS      , ASN_COUNTER   , RONLY , var_ifTable, 3, { 2,1,12 } },
#define   IFINDISCARDS          16
  { IFINDISCARDS        , ASN_COUNTER   , RONLY , var_ifTable, 3, { 2,1,13 } },
#define   IFINERRORS            17
  { IFINERRORS          , ASN_COUNTER   , RONLY , var_ifTable, 3, { 2,1,14 } },
#define   IFINUNKNOWNPROTOS     18
  { IFINUNKNOWNPROTOS   , ASN_COUNTER   , RONLY , var_ifTable, 3, { 2,1,15 } },
#define   IFOUTOCTETS           19
  { IFOUTOCTETS         , ASN_COUNTER   , RONLY , var_ifTable, 3, { 2,1,16 } },
#define   IFOUTUCASTPKTS        20
  { IFOUTUCASTPKTS      , ASN_COUNTER   , RONLY , var_ifTable, 3, { 2,1,17 } },
#define   IFOUTNUCASTPKTS       21
  { IFOUTNUCASTPKTS     , ASN_COUNTER   , RONLY , var_ifTable, 3, { 2,1,18 } },
#define   IFOUTDISCARDS         22
  { IFOUTDISCARDS       , ASN_COUNTER   , RONLY , var_ifTable, 3, { 2,1,19 } },
#define   IFOUTERRORS           23
  { IFOUTERRORS         , ASN_COUNTER   , RONLY , var_ifTable, 3, { 2,1,20 } },
#define   IFOUTQLEN             24
  { IFOUTQLEN           , ASN_GAUGE     , RONLY , var_ifTable, 3, { 2,1,21 } },
#define   IFSPECIFIC            25
  { IFSPECIFIC          , ASN_OBJECT_ID , RONLY , var_ifTable, 3, { 2,1,22 } },

};
/*    (L = length of the oidsuffix) */


/*
 * init_interfaces():
 *   Initialization routine.  This is called when the agent starts up.
 *   At a minimum, registration of your variables should take place here.
 */
void init_interfaces(void) {
    int i;
    struct timeval now, diff;

  /* register ourselves with the agent to handle our mib tree */
  REGISTER_MIB("interfaces", interfaces_variables, variable4,
               interfaces_variables_oid);


  /* place any other initialization junk you need here */

    interface_parms = (group_parameters_t *) \
                sal_alloc(sizeof(group_parameters_t), "interface_parms");

    /* get sysUpTime */
    gettimeofday(&now, NULL);
    now.tv_sec--;
    now.tv_usec += 1000000L;
    diff.tv_sec = now.tv_sec - starttime.tv_sec;
    diff.tv_usec = now.tv_usec - starttime.tv_usec;
    if (diff.tv_usec > 1000000L){
        diff.tv_usec -= 1000000L;
        diff.tv_sec++;
    }
    long_return = ((diff.tv_sec * 100) + (diff.tv_usec / 10000));

    for (i = 0; i < MAX_INTERFACE_NUM; i++) {
        interface_lastchange[i] = long_return;
    }
}

/*
 * var_interfaces():
 *   This function is called every time the agent gets a request for
 *   a scalar variable that might be found within your mib section
 *   registered above.  It is up to you to do the right thing and
 *   return the correct value.
 *     You should also correct the value of "var_len" if necessary.
 *
 *   Please see the documentation for more information about writing
 *   module extensions, and check out the examples in the examples
 *   and mibII directories.
 */
unsigned char *
var_interfaces(struct variable *vp, 
               oid     *name, 
               size_t  *length, 
               int     exact, 
               size_t  *var_len, 
               WriteMethod **write_method)
{
    

  static long long_ret;
  
  if ( MATCH_FAILED ==
       header_generic(vp,name,length,exact,var_len,write_method) )
    return NULL;
  
  /* 
   * this is where we do the value assignments for the mib results.
   */
  switch(vp->magic) {
      case IFNUMBER: {
        snmp_mib_setInterfaceCount ();
        long_ret = interface_count;
        return (unsigned char *) &long_ret;
      }
      default:
        ERROR_MSG("");
  }
  return NULL;
}

static int
header_ifPortTable(struct variable *vp,
           oid *name,
           size_t *length,
           int exact,
           size_t *var_len,
           WriteMethod **write_method)
{
#define IF_NAME_LENGTH  10
    AGENT_ENTER;
    oid newname[MAX_OID_LEN];
    int i, result;
    int port_number;
    int found = FALSE;

    memcpy( (char *)newname,(char *)vp->name, (int)vp->namelen * sizeof(oid));

    for(i = 1; i <= interface_count; i++) {
        /* Build an OID with this port, and loop */
        newname[IF_NAME_LENGTH] = (oid)i;
        result = snmp_oid_compare(
                    name, *length, newname, (int)vp->namelen + 1);
        if ((exact && (result == 0)) || (!exact && (result < 0))) {
            found = TRUE;
            port_number = i;
            break;
        }
    }

    /* TODO: Get AGG port info and loop through that also? */

    /* Let us return if we have not found anything */
    if ( found == FALSE ) {
        AGENT_EXIT;
        return MATCH_FAILED;
    }

    /* Set up the OID */
    memcpy( (char *)name,(char *)newname, ((int)vp->namelen + 1) * sizeof(oid));
    *length = vp->namelen + 1;
    *write_method = 0;
    *var_len = sizeof(long);

    AGENT_EXIT;
    return port_number;
}


/*
 * var_ifTable():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_interfaces above.
 */
unsigned char *
var_ifTable(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{
    /* variables we may use later */
    static long long_ret;
    static unsigned char string[SPRINT_MAX_LEN];
    static oid objid[MAX_OID_LEN];
    struct ifnet *ifp;
    int if_num, i;
    struct timeval now, diff;


    /* 
     * Since the interface_count variable will be used always.
     * Store it as a global variable.
     */
    snmp_mib_setInterfaceCount ();

    /* 
     * This assumes that the table is a 'simple' table.
     *	See the implementation documentation for the meaning of this.
     *	You will need to provide the correct value for the TABLE_SIZE parameter
     *
     * If this table does not meet the requirements for a simple table,
     * you will need to provide the replacement code yourself.
     * Mib2c is not smart enough to write this for you.
     * Again, see the implementation documentation for what is required.
     */
    if ( header_ifPortTable( vp,name,length,exact,var_len,write_method)
                                                         == MATCH_FAILED ) {
        return NULL;
    }

    if_num = name[ (*length)-1 ]; /* interface number is 1-based */
    i = if_num - 1; /* use i to access interface_lastchange array */

    interface_parms->uport = if_num;

    switch(vp->magic) {
        case IFINDEX:
            interface_parms->group_obj = IF_INDEX;
            break;
        case IFDESCR:
            interface_parms->group_obj = IF_DESCR;
            break;
        case IFTYPE:
            interface_parms->group_obj = IF_TYPE;
            break;
        case IFMTU:
            interface_parms->group_obj = IF_MTU;
            break;
        case IFSPEED:
            interface_parms->group_obj = IF_SPEED;
            break;
        case IFPHYSADDRESS:
            interface_parms->group_obj = IF_PHYSADDRESS;
            break;
        case IFADMINSTATUS:
            *write_method = write_ifAdminStatus;
            interface_parms->callback_rw = CALLBACK_ACT_READ;
            interface_parms->group_obj = IF_ADMINSTATUS;
            break;
        case IFOPERSTATUS:
            interface_parms->group_obj = IF_OPERSTATUS;
            break;
        case IFLASTCHANGE:
            interface_parms->group_obj = IF_LASTCHANGE;
            break;
        case IFINOCTETS:
            interface_parms->group_obj = IF_INOCTETS;
            break;
        case IFINUCASTPKTS:
            interface_parms->group_obj = IF_INUCASTPKTS;
            break;
        case IFINNUCASTPKTS:
            interface_parms->group_obj = IF_INNUCASTPKTS;
            break;
        case IFINDISCARDS:
            interface_parms->group_obj = IF_INDISCARDS;
            break;
        case IFINERRORS:
            interface_parms->group_obj = IF_INERRORS;
            break;
        case IFINUNKNOWNPROTOS:
            interface_parms->group_obj = IF_INUNKNOWNPROTOS;
            break;
        case IFOUTOCTETS:
            interface_parms->group_obj = IF_OUTOCTETS;
            break;
        case IFOUTUCASTPKTS:
            interface_parms->group_obj = IF_OUTUCASTPKTS;
            break;
        case IFOUTNUCASTPKTS:
            interface_parms->group_obj = IF_OUTNUCASTPKTS;
            break;
        case IFOUTDISCARDS:
            interface_parms->group_obj = IF_OUTDISCARDS;
            break;
        case IFOUTERRORS:
            interface_parms->group_obj = IF_OUTERRORS;
            break;
        case IFOUTQLEN:
            interface_parms->group_obj = IF_OUTQLEN;
            break;
        case IFSPECIFIC:
            interface_parms->group_obj = IF_SPECIFIC;
            break;
    	default:
            ERROR_MSG("");
            return NULL;
    }

    interface_parms->group = GROUP_INTERFACES;
    snmp_call_callbacks(SNMP_CALLBACK_APPLICATION, 
	                    SNMPD_CALLBACK_GROUPS,
                        interface_parms);

    if (IFDESCR == vp->magic) {
        /* return string */
        strcpy(string, interface_parms->buf);
        *var_len = strlen(string);
        return (unsigned char *) string;
   	} else if (IFPHYSADDRESS == vp->magic) {
   	    /* return Physical Address */
        bcopy(interface_parms->buf, string, ETHER_ADDR_LEN);
        *var_len = ETHER_ADDR_LEN;
        return (unsigned char *) string;
   	} else if (IFLASTCHANGE == vp->magic) {
   	    /* return sysUpTime */
        if (interface_parms->value == IF_LINK_CHANGED) {
            gettimeofday(&now, NULL);
            now.tv_sec--;
            now.tv_usec += 1000000L;
            diff.tv_sec = now.tv_sec - starttime.tv_sec;
            diff.tv_usec = now.tv_usec - starttime.tv_usec;
            if (diff.tv_usec > 1000000L){
                diff.tv_usec -= 1000000L;
                diff.tv_sec++;
            }
            long_return = ((diff.tv_sec * 100) + (diff.tv_usec / 10000));
            interface_lastchange[i] = long_return;
            return ((unsigned char *) &long_return);
        } else {
            return ((unsigned char *) &interface_lastchange[i]);
        }
   	} else {
   	    /* return value */
        long_return = (long)interface_parms->value;
        return (unsigned char *)&long_return;
   	}
}



int
write_ifAdminStatus(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static long *long_ret;
  int size, if_num, i;

  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to ifAdminStatus not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to ifAdminStatus: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          if (!var_val_len || (*(int *)var_val) < 1 || (*(int *)var_val) > 3) {
              return SNMP_ERR_WRONGVALUE;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = (long *) var_val;
          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for you to use,
             and you have just been asked to do something with it.  Note
             that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
            /* Things are working well, so it's now safe to make the change
               permanently.  Make sure that anything done here can't fail! */
            if_num = name[10];
            i = if_num;
            interface_parms->uport = if_num;
            switch(name[9]) {
            case 7: /* IFADMINSTATUS */ /* then according to the interface number to be saved */
                interface_parms->group_obj = IF_ADMINSTATUS;
                interface_parms->value = *long_ret;
                interface_parms->callback_rw = CALLBACK_ACT_WRITE;
                interface_parms->group = GROUP_INTERFACES;
                snmp_call_callbacks(SNMP_CALLBACK_APPLICATION, 
            	                    SNMPD_CALLBACK_GROUPS,
                                    interface_parms);
                return SNMP_ERR_NOERROR;
            default:
                return SNMP_ERR_NOSUCHNAME;
            }
          break;
  }
  return SNMP_ERR_NOERROR;
}

// EOF interfaces.c
