/* This should always be included first before anything else */
#include <config.h>

/* minimal include directives */
#include "mibincl.h"
#include "mibgroup/util_funcs.h"

#include "mibgroup/ng700ss/ng700ss.h"
#include <ucd-snmp/mibgroup/mibII/group_mib.h>
#include <ucd-snmp/mibgroup/ng700ss/netgear_mib.h>

/*
 *  Path to this MIB WRT the global MIB tree.
 */
oid ng700ss_variables_oid[] = { 1,3,6,1,4,1,4526,100,4,8 };

/* Variables that this MIB supports. Since this is just a path to the 
   actual groups, it supports nothing by itself */
struct variable7 ng700ss_variables[] = {
/*  No variables, as this is this is just for MIB tree start path */
};

/** Initializes the ng700ss module */
void
init_ng700ss_mib(void)
{
    AGENT_ENTER;

    /* register ourselves with the agent to handle our mib tree */
    REGISTER_MIB(SS_NGR_NG700_MIB, ng700ss_variables, variable7,
                                            ng700ss_variables_oid);
    init_ssHostGroup(); /* Host table */
    init_ssMiscGroup(); /*Misc */
    init_ssSpanGroup(); /* Spanning Tree */
    init_ssConfigGroup(); /* System Configuration */
    init_ssPVlanGroup();   /* Port-Based VLAN */
    init_ssTVlanGroup();  /* TVLAN */
    init_ssPortTrunkGroup(); /* Trunking */
    init_ssQosGroup(); /* QoS */
    init_ssStormCtrlGroup();
    init_ssTrustMACGroup();  /* Trust MAC */
    init_ssRateLimitGroup();
    init_ssIgmpSnoopGroup(); /* IGMP Snooping */
    init_ssStaticMulticastGroup(); /* Static Multicast */
    init_ssManagementVlan(); /* Management VLAN */

    AGENT_EXIT;

}

/*
 * var_ng700ss():
 *    Gets scalar values.
 */
unsigned char *
var_ng700ss(struct variable *vp,
                oid     *name,
                size_t  *length,
                int     exact,
                size_t  *var_len,
                WriteMethod **write_method)
{
    AGENT_ENTER;

    if (header_generic(vp,name,length,exact,var_len,write_method)
                                  == MATCH_FAILED ) {
        return NULL;
    }

    switch(vp->magic) {
        default:
          ERROR_MSG("");
    }

    AGENT_EXIT;
    return NULL;
}
